import 'dart:async';
import 'dart:convert';
import 'dart:io';

//import 'package:saker/framework/log/log.dart';

///发送GET HTTP 1.1
///
/// String result = await httpGet('http://11.162.87.222:8080/Hello');
///
Future<String> httpGet(String url, {Map<String, String> headers}) async {
  return _request('GET', url, headers: headers);
}



///发送POST HTTP 1.1
///
/// String result = await httpPost('http://11.162.87.222:8080/Hello');
///
Future<String> httpPost(String url, {Map<String, String> headers}) async {
  return _request('POST', url, headers: headers);
}

///发送Head HTTP 1.1
///
/// String result = await httpGet('http://www.baidu.com');
///
Future<String> httpHead(String url, {Map<String, String> headers}) async {
  return _request('HEAD', url, headers: headers);
}

Future<String> _request(String method, String url, {Map<String, String> headers}) async {
  Uri uri = Uri.parse(url);

  HttpClient client = new HttpClient();
  HttpClientRequest request = await client.openUrl(method, uri);

  if (headers != null && headers.isNotEmpty) {
    headers.forEach((k, v) {
      request.headers.add(k, v);
    });
  }

  HttpClientResponse response = await request.close();
  client.close();
  if (response == null) {
//    MyLogger.getLogger()?.error("Http Get error: response is null");
    return null;
  }

  if (response.statusCode == HttpStatus.ok) {
    String result = await response.transform(utf8.decoder).join();
    return result;
  }

//  MyLogger.getLogger()?.error("Http Get error: statusCode = ${response.statusCode}");
  return null;
}

main(List<String> args) async {
//  print(await httpGet('http://11.162.87.222:8080/StatService?data=%7B%22appName%22%3A%22xxx%22%7D'));
//  print(await httpGet('http://11.162.87.222:8080/Hello'));
//  print(await httpGet('http://11.162.87.222:8080/Hello'));
//  print(await httpPost('http://11.162.87.222:8080/Hello'));
}