import 'dart:async';
import 'dart:io';

import 'package:saker/common/net/http2.dart' as http2;

class HttpPool {
  HttpClient _httpClient = null;

  HttpClient getConnection() {
    if (_httpClient == null) {
      _httpClient = new HttpClient();
      _httpClient.maxConnectionsPerHost = 10;
    }
    return _httpClient;
  }

  Map<String, http2.ClientConnection> httpPool2 = {};

  Future<http2.ClientConnection> getConnectionHTTP2(String url) async {
    if (httpPool2.containsKey(url)) {
      return httpPool2[url];
    }
    http2.ClientConnection connection;
    await http2.connect(Uri.tryParse(url)).then((conn) {
      if (httpPool2.containsKey(url)) {
        conn.close();
        connection = httpPool2[url];
      } else {
        connection = conn;
      }
    });
    httpPool2[url] = connection;
    return connection;
  }
}

HttpPool httpPool = new HttpPool();