import 'dart:async';
import 'dart:io';

///获取本机IP
class IPAddress {
  String _hostIp = '127.0.0.1';

  final Duration dnsTimeOut = new Duration(seconds: 3);

  void init() async {
//    print('${new DateTime.now().toString()} Http server init: initIsolate->LocaleIpConfig.init() start');
    if(_hostIp == null || _hostIp == '' || _hostIp == '127.0.0.1') {
      try {
        await InternetAddress.lookup(Platform.localHostname, type: InternetAddressType.IPv4).then((v) {
          if (v != null && v.isNotEmpty) {
            _hostIp = v[0].address;
          }
        }).timeout(dnsTimeOut).catchError((dynamic e) {
          print('${new DateTime.now().toString()} Http server init: initIsolate->LocaleIpConfig.init() getLocaleIp error=${e}');
        });
      } catch (e) {
        print('${new DateTime.now().toString()} Http server init: initIsolate->LocaleIpConfig.init() getLocaleIp unexception=${e}');
      }
    }
    _completer.complete();
//    print('${new DateTime.now().toString()} Http server init: initIsolate->LocaleIpConfig.init() end, IP:${_hostIp}');
  }

  Completer _completer = new Completer();

  static Future completed() => _ipAddress._completer.future;

  static IPAddress _ipAddress = new IPAddress()..init();
  static String getHostIp() {
    return _ipAddress._hostIp;
  }
}