import 'dart:convert';
import 'dart:typed_data';
import 'package:convert/convert.dart';
import 'package:crypto/crypto.dart' as crypto;
import 'package:pointycastle/api.dart';
import 'package:pointycastle/block/aes_fast.dart';
import 'package:pointycastle/block/modes/cbc.dart';
import 'package:pointycastle/padded_block_cipher/padded_block_cipher_impl.dart';
import 'package:pointycastle/paddings/pkcs7.dart';

///加密工具集
class EncryptTools {
  static Uint8List _getIv(String privateKey) {
    var md5 = crypto.md5;
    var md5_digest = md5.convert(utf8.encode(privateKey));
    var key = hex.encode(md5_digest.bytes);
    var iv = utf8.encode(key).sublist(0, 16);
    return new Uint8List.fromList(iv);
  }

  ///AES加密
  static String encryptAesCbcWithPKCS7(String content, String privateKey) {
    if (content != null && content.length != 0) {
      try {
        var iv = _getIv(privateKey);

        KeyParameter keyParameter = new KeyParameter(iv);

        CBCBlockCipher cbcBlockCipher = new CBCBlockCipher(new AESFastEngine());
        ParametersWithIV parametersWithIV = new ParametersWithIV(
            keyParameter, iv);

        PaddedBlockCipher paddedBlockCipher = new PaddedBlockCipherImpl(
            new PKCS7Padding(), cbcBlockCipher);

        CipherParameters parameters = new PaddedBlockCipherParameters(
            parametersWithIV, null);

        paddedBlockCipher.init(true, parameters);

        var cipher_val = paddedBlockCipher.process(new Uint8List.fromList(utf8.encode(content)));

        return base64.encode(cipher_val);
      } catch (e) {
      }
    }

    return null;
  }


 static String decrypt(String content, String privateKey) {
    if (content != null && content.length != 0) {
//      var iv = getIv(privateKey);

//      CipherParameters params = new PaddedBlockCipherParameters(
//          new ParametersWithIV(new KeyParameter(key), iv), null);
//        BlockCipher decryptionCipher = new PaddedBlockCipher("AES/CBC/PKCS7");
//        decryptionCipher.init(false, params);
//        String decrypted = UTF8.decode(decryptionCipher.process(BASE64.decode(content)));
//
//        print("Decrypted: \n$decrypted");
//
//        return decrypted;

    }

    return null;
  }
}


