
String makeQuery(Map<String, dynamic> queryParameters) {

  if (queryParameters == null) return null;

  var result = new StringBuffer();
  var separator = "";

  void writeParameter(String key, String value) {
    result.write(separator);
    separator = "&";
    result.write(Uri.encodeQueryComponent(key));
    if (value != null && value.isNotEmpty) {
      result.write("=");
      result.write(Uri.encodeQueryComponent(value));
    }
  }

  queryParameters.forEach((key, value) {
    if (value == null || value is String) {
      writeParameter(key, value as String);
    } else {
      Iterable<String> values = (value as Iterable)?.cast();
      for (String value in values) {
        writeParameter(key, value);
      }
    }
  });
  return result.toString();
}