

import '../aliyun/kv_store/aliyun_kv_store.dart';
import '../interfaces/kv_store.dart';

import './config/baas_config.dart';
import './database/aliyun_data_base.dart';
import './request/http_conn_pool.dart';
import '../baas_sdk.dart';
import '../interfaces/database.dart';
import '../interfaces/file.dart';
import 'package:saker/framework/log/log.dart';
import 'package:saker/framework/config/frame_work_config_manager.dart';


class MBaasSDKAliyun implements MBaasSDK{
  bool inited;
  HttpConnPool httpPool ;

  MBaasSDK(){
    inited = false;
  }

  bool init(Map<String,dynamic> config, Logger logger, BaasEnv baasEnv){

    if(config.containsKey("appID") &&
        config.containsKey("envId") && config.containsKey("masterKey") ){
      baasSDKConfigAliyun.fromJson(config);

      baasSDKConfigAliyun.logger = logger;
      if(baasEnv == BaasEnv.preProduct || baasEnv == BaasEnv.daily){
        baasSDKConfigAliyun.host = FrameWorkSwitchManager.preBaasHost;//"pre-baas-service-aliyun-com.vipserver";
        baasSDKConfigAliyun.schema = "http";
      }else if(baasEnv == BaasEnv.product){
        baasSDKConfigAliyun.host = FrameWorkSwitchManager.baasHost;
        baasSDKConfigAliyun.schema = "http";
      }
      logger?.debug("baasSDKConfigAliyun:${baasSDKConfigAliyun.toString()}");
    }else{
      print("Aliyun MBaasSDK init configure must set your AppID, envId, masterKey, please check and try");
      return false;
    }

    httpPool = httpConnPool;
    inited = true;
    return true;
  }



  DataBase getDB(String collName){

    if(collName == null || collName.isEmpty){
      print("No TableName ....");
      return null;
    }

    return new AliYunDataBase(collName,baasSDKConfigAliyun.logger);

  }

  KVStore getKVStore(String collName){

    if(collName == null || collName.isEmpty){
      print("No TableName ....");
      return null;
    }

    return new AliYunKVStore(collName,baasSDKConfigAliyun.logger);

  }


  OSSFile getOSSFile(){
    return null;
  }

}

