import 'dart:convert';

import '../../baas_sdk.dart';

import '../../interfaces/baas_object.dart';

import '../request/request_utils.dart';
import '../../interfaces/database.dart';
import 'package:saker/framework/log/log.dart';


void main(List<String> args) async {
  DataBase db  = _getDB();
//  db.upsert(queryParamJson, upsertParamJson)
  Map<String, dynamic> queryItem = new Map<String, dynamic>();
  queryItem.putIfAbsent('userId', ()=>12345);
  queryItem.putIfAbsent('itemId', ()=>11111);
  queryItem.putIfAbsent('provider', ()=>0);
  queryItem.putIfAbsent('sort', ()=>1);
  queryItem.putIfAbsent('date', ()=>99999);

  Map<String, dynamic> upsertItem = new Map<String, dynamic>();
  upsertItem.putIfAbsent("time", ()=>8888888888);

  BaasDBUpsertResult upsertResult  = await db.upsert(queryItem, upsertItem);
 print(upsertResult.toString());
  BaasDBGetResult getResult = await db.get(queryItem, 0, 100, null);
  print(getResult.toString());
}

/// Baas
DataBase _getDB() {
  // config
  Map<String, String> config = {
    "envId": "LCwxIZLS3gORsJn8",
    "appID": "yXP9p9MynlEN9hjL",
    "masterKey": "UTwObr2QXpTcE0ymEHsuAvBWTprIqg9Gdw9l"};
  // MBaasSDK
  MBaasSDK mBaasSDK = MBaasSDK.getMBaasSDK(config,
      logger: MyLogger.getLogger(), baasEnv:BaasEnv.product , baasProvider: BaasProvider.aliyun);
  if (mBaasSDK == null) {
    throw Exception('Baas初始化失败');
  }
  // db
  DataBase db = mBaasSDK.getDB('XianYuItemTrackDB');
  if (db == null) {
    throw Exception('DB初始化失败');
  }
  return db;
}

Future<List<String>> _getOneDay(DataBase db, Map<String, dynamic> item) async {
  // get
  Map<String, dynamic> query = <String, dynamic>{};
  query['userId'] = item['userId'];
  query['itemId'] = item['itemId'];
  query['provider'] = item['provider'];
  query['sort'] = item['sort'];
  query['date'] = item['date'];

  //  /// item
  //  Map<String, dynamic> item = <String, dynamic>{};
  //  item['userId'] = userId; // int
  //  item['itemId'] = itemId; // int
  //  item['provider'] = provider; // 数据来源[0:闲鱼,1:社区]
  //  item['sort'] = sort; // 分类[0:浏览,1:点赞,2:留言]
  //  item['date'] = new DateTime(time.year, time.month, time.day).millisecondsSinceEpoch;
  //  item['time'] = time.millisecondsSinceEpoch;
  //  return item;

  BaasDBGetResult getResult = await db.get(query, 0, 100, null);
  if (getResult == null || getResult.success == false) {
    throw Exception('getResult: ${getResult?.toString()}');
  }
  // getResult
  List<String> list = <String>[];
  if (getResult.items.length > 0) {
    for (Map map in getResult.items) {
      list.add(map['objectId'] as String);
    }
  }
  return list;
}