


import 'interfaces/kv_store.dart';

import './aliyun/baas_sdk_aliyun.dart';

import './interfaces/database.dart';
import './interfaces/file.dart';
import 'package:saker/framework/log/log.dart';


abstract class MBaasSDK{
  static Map<BaasProvider, MBaasSDK> _baasSDKs={};//兼容用户同时使用多个Baas产品

  bool init(Map<String,dynamic> config, Logger logger, BaasEnv baasEnv);

  DataBase getDB(String collName);

  KVStore getKVStore(String name);

  OSSFile getOSSFile();

  static MBaasSDK getMBaasSDK(Map<String,dynamic> config,{Logger logger:null, BaasEnv baasEnv:BaasEnv.preProduct, BaasProvider baasProvider:BaasProvider.aliyun}){
    if(_baasSDKs != null && _baasSDKs.containsKey(baasProvider) && _baasSDKs[baasProvider] != null){
      return _baasSDKs[baasProvider];
    }

    if(baasProvider == BaasProvider.aliyun){
      MBaasSDK _baasSDK = new MBaasSDKAliyun();
      bool initRes = _baasSDK.init(config,logger,baasEnv);
      if(initRes){
        _baasSDKs[baasProvider] = _baasSDK;
        return _baasSDK;
      }

      return null;
    }
  }
}

enum BaasProvider{
  aliyun,
//  firebase
}


enum BaasEnv{
  daily,
  preProduct,
  product
}