
class KVStoreOpResult{
  int resCode;
  String result;

  String toString(){
    return "resCode:$resCode; result:$result";
  }
}

const Duration baasKVOpTimeout = const Duration(microseconds: 4000);

abstract class KVStore{

  Future<KVStoreOpResult> put_async(String key,String value, {int kvStoreTimeout: 3600*1000,Duration apiTimeout : baasKVOpTimeout});
  Future<KVStoreOpResult> remove_async(String key, {Duration apiTimeout : baasKVOpTimeout});
  Future<KVStoreOpResult> get_async(String key, {Duration apiTimeout : baasKVOpTimeout});

  Future<Map<String,KVStoreOpResult>> mremove_async(List<String> keys,{ Duration apiTimeout:baasKVOpTimeout});
  Future<Map<String,KVStoreOpResult>> mput_async(Map<String,String> map,{int kvStoreTimeout: 3600*1000,int version : 0, Duration apiTimeout:baasKVOpTimeout});
  Future<Map<String,KVStoreOpResult>> mget_async(List<String> keys,{ Duration apiTimeout:baasKVOpTimeout});
//  Future<KVStoreOpResult> put_subkey_async(String key, String subKey, String value, {Duration timeout : baasKVOpTimeout});
//  Future<KVStoreOpResult> remove_subkey_async(String key, String subKey, {Duration timeout : baasKVOpTimeout});
//  Future<KVStoreOpResult> get_subkey_async(String key, String subKey, {Duration timeout : baasKVOpTimeout});
}