import 'dart:async';
import 'dart:convert';
import 'dart:isolate';

import 'package:saker/framework/event/event_pool_base.dart';
import 'package:saker/framework/hsf/hsf_async.dart';
import 'package:saker/framework/hsf/hsf_provider_base.dart';
import 'package:saker/framework/log/log.dart';

//void dart_load_hsf_results(var messages) {
//
//}

class EventPool extends EventPoolBase{
  EventPool() {
    receivePort = new ReceivePort();
    StreamSubscription subscription;
    subscription = receivePort.listen((var msg) async {
      if (msg is int) {
        if (msg == EventType_Hsf_Pull) {
          List results = hsf_get_response(hsfResultAddress);
          results.forEach((result) {
//            int taskId = getFutureID(result);
//            int successFlag = getSuccessFlag(result);
//            MyLogger.getDebugLogger()?.debug("get response:taskID:$taskId, succ?:$successFlag result:$result");
//            EventPool.doTask([taskId,successFlag,result]);
            MyLogger.getDebugLogger()?.debug(json.encode(result));
            EventPool.doTask(result);
          });
        } else if (msg == EventType_Hsf_Req) {
          List requests = hsf_get_request(hsfRequestAddress);
          for (dynamic element in requests) {
            if (element is List) {
              HsfProviderBase.dispatch(element);
            }
          }
        }
      } else if (msg is List) {
        if (msg[0] == EventType_Any) {
          doTask([msg[1], msg[2], msg[3]]);
        } else if (msg[0] == EventType_Notice) {
          if (notice_cb != null && msg.length == 2) {
            notice_cb(msg[1]);
          }
        }
        else if(msg[0] == EventType_Traffic_Guard){
          if(traffic_guard_cb !=null){
            traffic_guard_cb(msg[1]);
          }
        }
      }
    }, onDone: () {
      health = false;
      subscription.cancel();
    });
  }

  static event_callback traffic_guard_cb = null;
  static event_callback notice_cb = null;
//  static event_callback hsf_cb = dart_load_hsf_results;
  //单例模式
  static EventPool pool = new EventPool();

  static EventItem getEvent() {
    return pool.getEventReal();
  }
  static void doTask(var msg) {
    pool.doTaskReal(msg);
  }
  static void remove(int taskId) {
    pool.completerMap.remove(taskId);
  }
  static SendPort get sendPort => pool.receivePort.sendPort;
  static Map<int,Completer> getCompleterMap() => pool.completerMap;
}