import 'dart:async';
import 'dart:isolate';

import 'package:saker/framework/event/event_pool_base.dart';
import 'package:saker/framework/hsf/hsf_async.dart';
import 'package:saker/framework/hsf/hsf_provider_base.dart';


class HsfProviderEventPool extends EventPoolBase{

  HsfProviderEventPool() {
    receivePort = new ReceivePort();

    StreamSubscription subscription;
    subscription = receivePort.listen((var msg) {
      if (msg is int) {
        List requests = hsf_get_request(msg);
        HsfProviderBase.dispatch(requests);
      }
    }, onDone: () {
      health = false;
      subscription.cancel();
    });
  }

  //单例
  static EventPoolBase pool = new HsfProviderEventPool();

  static EventItem getEvent() {
    return pool.getEventReal();
  }
  static void doTask(var msg) {
    pool.doTaskReal(msg);
  }
  static void remove(int taskId) {
    pool.completerMap.remove(taskId);
  }
  static SendPort get sendPort => pool.receivePort.sendPort;
  static Map<int,Completer> getCompleterMap(){
    return pool.completerMap;
  }

}