import 'dart:async';
import 'dart:isolate';

import 'package:saker/framework/event/event_pool_base.dart';
import 'package:saker/framework/tair/dart_tair_extension_interface.dart';


class TairEventPool extends EventPoolBase{

  TairEventPool() {
    receivePort = new ReceivePort();

    StreamSubscription subscription;
    subscription = receivePort.listen((var msg) {
      if (msg is int) {
        if(msg == EventType_Tair_Pull ){
          List results = tair_get_response(TairEventPool.sendPort);
          results.forEach((results) { TairEventPool.doTask(results);});
        }
      }
    }, onDone: () {
      health = false;
      subscription.cancel();
    });
  }

  //单例
  static EventPoolBase pool = new TairEventPool();

  static EventItem getEvent() {
    return pool.getEventReal();
  }
  static void doTask(var msg) {
    pool.doTaskReal(msg);
  }
  static void remove(int taskId) {
    pool.completerMap.remove(taskId);
  }
  static SendPort get sendPort => pool.receivePort.sendPort;
  static Map<int,Completer> getCompleterMap(){
    return pool.completerMap;
  }

}