const int BC_BINARY = 66; //'B'; // const chunk
const int BC_BINARY_CHUNK = 65; //'A'; // non-const chunk
const int BC_BINARY_DIRECT = 0x20; // 1-byte length binary
const int BINARY_DIRECT_MAX = 0x0f;
const int BC_BINARY_SHORT = 0x34; // 2-byte length binary
const int BINARY_SHORT_MAX = 0x3ff; // 0-1023 binary

const int BC_CLASS_DEF = 67; //'C'; // object/class definition

const int BC_DATE = 0x4a; // 64-bit millisecond UTC date
const int BC_DATE_MINUTE = 0x4b; // 32-bit minute UTC date

const int BC_DOUBLE = 68; //'D'; // IEEE 64-bit double

const int BC_DOUBLE_ZERO = 0x5b;
const int BC_DOUBLE_ONE = 0x5c;
const int BC_DOUBLE_BYTE = 0x5d;
const int BC_DOUBLE_SHORT = 0x5e;
const int BC_DOUBLE_MILL = 0x5f;

const int BC_FALSE = 70; //'F'; // bool false

const int BC_INT = 73; //'I'; // 32-bit int

const int INT_DIRECT_MIN = -0x10;
const int INT_DIRECT_MAX = 0x2f;
const int BC_INT_ZERO = 0x90;

const int INT_BYTE_MIN = -0x800;
const int INT_BYTE_MAX = 0x7ff;
const int BC_INT_BYTE_ZERO = 0xc8;

const int BC_END = 90; //'Z';

const int INT_SHORT_MIN = -0x40000;
const int INT_SHORT_MAX = 0x3ffff;
const int BC_INT_SHORT_ZERO = 0xd4;

const int BC_LIST_VARIABLE =0x55;
const int BC_LIST_FIXED = 86; //'V';
const int BC_LIST_VARIABLE_UNTYPED = 0x57;
const int BC_LIST_FIXED_UNTYPED =0x58;

const int BC_LIST_DIRECT = 0x70;
const int BC_LIST_DIRECT_UNTYPED = 0x78;
const int LIST_DIRECT_MAX = 0x7;

const int BC_LONG = 76; //'L'; // 64-bit signed integer
const int LONG_DIRECT_MIN = -0x08;
const int LONG_DIRECT_MAX =  0x0f;
const int BC_LONG_ZERO = 0xe0;

const int LONG_BYTE_MIN = -0x800;
const int LONG_BYTE_MAX =  0x7ff;
const int BC_LONG_BYTE_ZERO = 0xf8;

const int LONG_SHORT_MIN = -0x40000;
const int LONG_SHORT_MAX = 0x3ffff;
const int BC_LONG_SHORT_ZERO = 0x3c;

const int BC_LONG_INT = 0x59;

const int BC_MAP = 77; //'M';
const int BC_MAP_UNTYPED = 72; //'H';

const int BC_NULL = 78; //'N';

const int BC_OBJECT = 79; //'O';
const int BC_OBJECT_DEF = 67; //'C';

const int BC_OBJECT_DIRECT = 0x60;
const int OBJECT_DIRECT_MAX = 0x0f;

const int BC_REF = 0x51;

const int BC_STRING = 83; //'S'; // const string
const int BC_STRING_CHUNK = 82; //'R'; // non-const string
const int H1_BC_STRING_CHUCK = 115;//'s'

const int BC_STRING_DIRECT = 0x00;
const int STRING_DIRECT_MAX = 0x1f;
const int BC_STRING_SHORT = 0x30;
const int STRING_SHORT_MAX = 0x3ff;

const int BC_TRUE = 84; //'T';

const int P_PACKET_CHUNK = 0x4f;
const int P_PACKET = 80; //'P';

const int P_PACKET_DIRECT = 0x80;
const int PACKET_DIRECT_MAX = 0x7f;

const int P_PACKET_SHORT = 0x70;
const int PACKET_SHORT_MAX = 0xfff;