import 'dart:typed_data';

import 'package:saker/framework/hessian/hessian2_const.dart';
import 'package:saker/framework/hessian/hessian_object_base.dart';
import 'package:saker/framework/hessian/identity_int_map.dart';

class ChunkBlock2 {
  int bytesLen = 0;
  Uint8List buffer;
}

class Hessian2Output {
  // should match Resin buffer size for perf
  static int SIZE = 8 * 1024;

  // map of references
  IdentityIntMap _refs = new IdentityIntMap(256);

  int _refCount = 0;

  // map of classes
  final IdentityIntMap _classRefs = new IdentityIntMap(256);

  // map of types
  Map<String, int> _typeRefs;

  Uint8List _buffer;
  ByteData _byteData;


  List<ChunkBlock2> _chunkBlocks = new List();
  int _totalBytes = 0;

  int _offset;

  bool _isPacket;

  bool _isUnshared;

  /**
   * Creates a new Hessian output stream, initialized with an
   * underlying output stream.
   *
   * @param os the underlying output stream.
   */
  Hessian2Output() {
    _refCount = 0;

    _classRefs.clear();
    _typeRefs = null;
    _offset = 0;
    _isPacket = false;
    _isUnshared = false;

    _isPacket = false;
    _offset = 0;
    _buffer = new Uint8List(SIZE);
    _byteData = new ByteData.view(_buffer.buffer);
  }

//
//  void init(OutputStream os)
//  {
//    reset();
//
//    _os = os;
//  }

//  void initPacket(OutputStream os)
//  {
//    resetReferences();
//
//    _os = os;
//  }

  /**
   * Sets hessian to be "unshared", meaning it will not detect
   * duplicate or circular references.
   */

  bool setUnshared(bool isUnshared) {
    bool oldIsUnshared = _isUnshared;

    _isUnshared = isUnshared;

    return oldIsUnshared;
  }

  /**
   * Writes a complete method call.
   */

//  void call(String method, Object []args)
//
//  {
//  writeVersion();
//
//  int length = args != null ? args.length : 0;
//
//  startCall(method, length);
//
//  for (int i = 0; i < length; i++) {
//  writeObject(args[i]);
//  }
//
//  completeCall();
//
//  flush();
//  }

  /**
   * Starts the method call.  Clients would use <code>startCall</code>
   * instead of <code>call</code> if they wanted finer control over
   * writing the arguments, or needed to write headers.
   *
   * <code><pre>
   * C
   * string # method name
   * int    # arg count
   * </pre></code>
   *
   * @param method the method name to call.
   */

//void startCall(String method, int length)
//
//{
//int offset = _offset;
//
//if (SIZE < offset + 32) {
//flushBuffer();
//offset = _offset;
//}
//
//byte []buffer = _buffer;
//
//buffer[_offset++] = (byte) 'C';
//
//writeString(method);
//writeInt(length);
//}
//
  ///**
// * Writes the call tag.  This would be followed by the
// * method and the arguments
// *
// * <code><pre>
// * C
// * </pre></code>
// *
// * @param method the method name to call.
// */
//
//void startCall()
//
//{
//flushIfFull();
//
//_buffer[_offset++] = (byte) 'C';
//}
//
  ///**
// * Starts an envelope.
// *
// * <code><pre>
// * E major minor
// * m b16 b8 method-name
// * </pre></code>
// *
// * @param method the method name to call.
// */
//void startEnvelope(String method)
//
//{
//int offset = _offset;
//
//if (SIZE < offset + 32) {
//flushBuffer();
//offset = _offset;
//}
//
//_buffer[_offset++] = (byte) 'E';
//
//writeString(method);
//}
//
  ///**
// * Completes an envelope.
// *
// * <p>A successful completion will have a single value:
// *
// * <pre>
// * Z
// * </pre>
// */
//void completeEnvelope()
//
//{
//flushIfFull();
//
//_buffer[_offset++] = (byte) 'Z';
//}
//
  ///**
// * Writes the method tag.
// *
// * <code><pre>
// * string
// * </pre></code>
// *
// * @param method the method name to call.
// */
//void writeMethod(String method)
//
//{
//writeString(method);
//}
//
  ///**
// * Completes.
// *
// * <code><pre>
// * z
// * </pre></code>
// */
//
//void completeCall()
//
//{
  ///*
//    flushIfFull();
//
//    _buffer[_offset++] = (byte) 'Z';
//    */
//}
//
  /**
   * Starts the reply
   *
   * <p>A successful completion will have a single value:
   *
   * <pre>
   * R
   * </pre>
   */

//void startReply()
//
//{
//writeVersion();
//
//flushIfFull();
//
//_buffer[_offset++] = (byte) 'R';
//}

  void writeVersion() {
    flushIfFull();

//_buffer[_offset++] = (byte) 'H';
    _byteData.setUint8(_offset++, 72);
    _byteData.setUint8(_offset++, 2);
    _byteData.setUint8(_offset++, 0);
  }

  ///**
// * Completes reading the reply
// *
// * <p>A successful completion will have a single value:
// *
// * <pre>
// * z
// * </pre>
// */
//
//void completeReply()
//
//{
//}
//
  ///**
// * Starts a packet
// *
// * <p>A message contains several objects encapsulated by a length</p>
// *
// * <pre>
// * p x02 x00
// * </pre>
// */
//void startMessage()
//
//{
//flushIfFull();
//
//_buffer[_offset++] = (byte) 'p';
//_buffer[_offset++] = (byte) 2;
//_buffer[_offset++] = (byte) 0;
//}
//
  ///**
// * Completes reading the message
// *
// * <p>A successful completion will have a single value:
// *
// * <pre>
// * z
// * </pre>
// */
//void completeMessage()
//
//{
//flushIfFull();
//
//_buffer[_offset++] = (byte) 'z';
//}
//
  ///**
// * Writes a fault.  The fault will be written
// * as a descriptive string followed by an object:
// *
// * <code><pre>
// * F map
// * </pre></code>
// *
// * <code><pre>
// * F H
// * \x04code
// * \x10the fault code
// *
// * \x07message
// * \x11the fault message
// *
// * \x06detail
// * M\xnnjavax.ejb.FinderException
// *     ...
// * Z
// * Z
// * </pre></code>
// *
// * @param code the fault code, a three digit
// */
//void writeFault(String code, String message, Object detail)
//{
//flushIfFull();
//
//writeVersion();
//
//_buffer[_offset++] = (byte) 'F';
//_buffer[_offset++] = (byte) 'H';
//
//addRef(new Object(), _refCount++, false);
//
//writeString("code");
//writeString(code);
//
//writeString("message");
//writeString(message);
//
//if (detail != null) {
//writeString("detail");
//writeObject(detail);
//}
//
//flushIfFull();
//_buffer[_offset++] = (byte) 'Z';
//}
//
  /**
   * Writes any object to the output stream.
   */
  void writeObject(HessianObjectBase object,
      Map<String, generic_hessian_func> genericMap) {
    if (object == null) {
      writeNull();
      return;
    }

    object.writeHessian2(this, genericMap);
  }

  void writeObjectValue(String type, dynamic val, Map<String, generic_hessian_func> genericMap) {
    if (type.startsWith('[')) {
      if (val == null) {
        writeNull();
        return;
      }

      if (addRef(val))
        return;

      if (type == '[byte') {
        if (val is Uint8List) {
          writeBytes(val);
        } else if (val is List<int>) {
          writeBytes(new Uint8List.fromList(val));
        }
        return;
      }
      if (type == '[char') {
        writeString(val as String);
        return;
      }

      if (val is List) {
        bool hasEnd = writeListBegin(val.length, type);
        val.forEach((e) => writeObjectValue(type.substring(1), e, genericMap));

        if (hasEnd)
          writeListEnd();
      } else {
        writeNull();
      }
      return;
    }

    switch (type) {
      case 'java.lang.String':
      case 'String':
      case 'java.lang.Character':
        writeString(val as String);
        break;
      case 'boolean':
        if (val == null) {
          writeBoolean(false);
          break;
        }
        writeBoolean(val as bool);
        break;
      case 'java.lang.Boolean':
        if (val == null) {
          writeNull();
          break;
        }
        writeBoolean(val as bool);
        break;
      case 'byte':
      case 'short':
      case 'int':
        if (val == null) {
          writeInt(0);
          break;
        }
        writeInt(val as int);
        break;
      case 'java.lang.Byte':
      case 'java.lang.Short':
      case 'java.lang.Integer':
        if (val == null) {
          writeNull();
          break;
        }
        writeInt(val as int);
        break;
      case 'long':
        if (val == null) {
          writeLong(0);
          break;
        }
        writeLong(val as int);
        break;
      case 'java.lang.Long':
        if (val == null) {
          writeNull();
          break;
        }
        writeLong(val as int);
        break;
      case 'java.lang.Float':
      case 'java.lang.Double':
        if (val == null) {
          writeNull();
          break;
        }
        writeDouble(val as double);
        break;
      case 'float':
      case 'double':
        if (val == null) {
          writeDouble(0.0);
          break;
        }
        writeDouble(val as double);
        break;
      case 'java.util.Date':
        if (val == null) {
          writeNull();
          break;
        }
        writeUTCDate(val as DateTime);
        break;
      default:
        if (val == null) {
          writeNull();
          break;
        }
        if (val is HessianObjectBase) {
          writeObject(val, genericMap);
        } else {
          throw new Exception('Class must implements HessianObjectBase');
        }
        break;
    }
  }

//void writeArrayValue<E>(String type, List<E> val, void f(E element)) {
//  if (addRef(val))
//    return;
//
//  if (val is List) {
//    bool hasEnd = writeListBegin(val.length, type);
//
//    val.forEach((i) => f(i));
//
//    if (hasEnd)
//      writeListEnd();
//  } else {
//    writeNull();
//  }
//}

  void writeListValue<E>(List<E> val, void f(E element)) {
    if (val == null) {
      writeNull();
      return;
    }

    if (addRef(val)) {
      return;
    }

    bool hasEnd = writeListBegin(val.length, null);

    val.forEach((i) => f(i));

    if (hasEnd) {
      writeListEnd();
    }
  }

  void writeSetValue<E>(Set<E> val, void f(E element)) {
    if (val == null) {
      writeNull();
      return;
    }

    if (addRef(val)) {
      return;
    }

    bool hasEnd = writeListBegin(val.length, 'java.util.HashSet');

    val.forEach((i) => f(i));

    if (hasEnd) {
      writeListEnd();
    }
  }

  void writeMapValue<K, V>(Map<K, V> val, void f(K k, V v)) {
    if (val == null) {
      writeNull();
      return;
    }

    if (addRef(val)) {
      return;
    }

    writeMapBegin(null);

    val.forEach((k, v) => f(k, v));

    writeMapEnd();
  }

  void writeDefinition20(List<String> _fields) {
    writeClassFieldLength(_fields.length);

    for (int i = 0; i < _fields.length; i++) {
      writeString(_fields[i]);
    }
  }

  /**
   * Writes the list header to the stream.  List writers will call
   * <code>writeListBegin</code> followed by the list contents and then
   * call <code>writeListEnd</code>.
   *
   * <code><pre>
   * list ::= V type value* Z
   *      ::= v type int value*
   * </pre></code>
   *
   * @return true for variable lists, false for fixed lists
   */
  bool writeListBegin(int length, String type) {
    flushIfFull();

    if (length < 0) {
      if (type != null) {
        _byteData.setUint8(_offset++, BC_LIST_VARIABLE);
        writeType(type);
      } else
        _byteData.setUint8(_offset++, BC_LIST_VARIABLE_UNTYPED);
      return true;
    } else if (length <= LIST_DIRECT_MAX) {
      if (type != null) {
        _byteData.setUint8(_offset++, BC_LIST_DIRECT + length);
        writeType(type);
      }
      else {
        _byteData.setUint8(_offset++, BC_LIST_DIRECT_UNTYPED + length);
      }

      return false;
    }
    else {
      if (type != null) {
        _byteData.setUint8(_offset++, BC_LIST_FIXED);
        writeType(type);
      }
      else {
        _byteData.setUint8(_offset++, BC_LIST_FIXED_UNTYPED);
      }

      writeInt(length);

      return false;
    }
  }

  /**
   * Writes the tail of the list to the stream for a variable-length list.
   */
  void writeListEnd() {
    flushIfFull();

    _byteData.setUint8(_offset++, BC_END);
  }


  /**
   * Writes the map header to the stream.  Map writers will call
   * <code>writeMapBegin</code> followed by the map contents and then
   * call <code>writeMapEnd</code>.
   *
   * <code><pre>
   * map ::= M type (<value> <value>)* Z
   *     ::= H (<value> <value>)* Z
   * </pre></code>
   */
  void writeMapBegin(String type) {
    if (SIZE < _offset + 32)
      flushBuffer();

    if (type != null) {
      _byteData.setUint8(_offset++, BC_MAP);

      writeType(type);
    }
    else
      _byteData.setUint8(_offset++, BC_MAP_UNTYPED);
  }

  /**
   * Writes the tail of the map to the stream.
   */
  void writeMapEnd() {
    if (SIZE < _offset + 32)
      flushBuffer();

    _byteData.setUint8(_offset++, BC_END);
  }

  /**
   * Writes the object definition
   *
   * <code><pre>
   * C &lt;string> &lt;int> &lt;string>*
   * </pre></code>
   */
  int writeObjectBegin(String type) {
    int newRef = _classRefs.size();
    int ref = _classRefs.put(type, newRef, false);

    if (newRef != ref) {
      if (SIZE < _offset + 32)
        flushBuffer();

      if (ref <= OBJECT_DIRECT_MAX) {
        _byteData.setUint8(_offset++, BC_OBJECT_DIRECT + ref);
      } else {
        _byteData.setUint8(_offset++, 79); //O
        writeInt(ref);
      }

      return ref;
    } else {
      if (SIZE < _offset + 32)
        flushBuffer();

      _byteData.setUint8(_offset++, 67); //C

      writeString(type);

      return -1;
    }
  }

  /**
   * Writes the tail of the class definition to the stream.
   */

  void writeClassFieldLength(int len) {
    writeInt(len);
  }

  /**
   * Writes the tail of the object definition to the stream.
   */
  void writeObjectEnd() {
  }

  /**
   * <code><pre>
   * type ::= string
   *      ::= int
   * </code></pre>
   */
  void writeType(String type) {
    flushIfFull();

    int len = type.length;
    if (len == 0) {
      throw new Exception("empty type is not allowed");
    }

    if (_typeRefs == null)
      _typeRefs = new Map<String, int>();

    int typeRefV = _typeRefs[type];

    if (typeRefV != null) {
      int typeRef = typeRefV;

      writeInt(typeRef);
    }
    else {
      _typeRefs[type] = _typeRefs.length;

      writeString(type);
    }
  }

  /**
   * Writes a bool value to the stream.  The bool will be written
   * with the following syntax:
   *
   * <code><pre>
   * T
   * F
   * </pre></code>
   *
   * @param value the bool value to write.
   */

  void writeBoolean(bool value) {
    if (SIZE < _offset + 16)
      flushBuffer();

    if (value)
      _byteData.setUint8(_offset++, 84); //T
    else
      _byteData.setUint8(_offset++, 70); //F
  }

  /**
   * Writes an integer value to the stream.  The integer will be written
   * with the following syntax:
   *
   * <code><pre>
   * I b32 b24 b16 b8
   * </pre></code>
   *
   * @param value the integer value to write.
   */

  void writeInt(int value) {
    int offset = _offset;

    if (SIZE <= offset + 16) {
      flushBuffer();
      offset = _offset;
    }

    if (INT_DIRECT_MIN <= value && value <= INT_DIRECT_MAX)
      _byteData.setUint8(offset++, value + BC_INT_ZERO);
    else if (INT_BYTE_MIN <= value && value <= INT_BYTE_MAX) {
      _byteData.setUint8(offset++, BC_INT_BYTE_ZERO + (value >> 8));
      _byteData.setUint8(offset++, value);
    }
    else if (INT_SHORT_MIN <= value && value <= INT_SHORT_MAX) {
      _byteData.setUint8(offset++, BC_INT_SHORT_ZERO + (value >> 16));
      _byteData.setUint8(offset++, value >> 8);
      _byteData.setUint8(offset++, value);
    } else {
      _byteData.setUint8(offset++, 73); //I
//    _byteData.setUint8(offset++, value >> 24);
//    _byteData.setUint8(offset++, value >> 16);
//    _byteData.setUint8(offset++, value >> 8);
//    _byteData.setUint8(offset++, value);
      _byteData.setUint32(offset, value);
      offset += 4;
    }

    _offset = offset;
  }

  /**
   * Writes a long value to the stream.  The long will be written
   * with the following syntax:
   *
   * <code><pre>
   * L b64 b56 b48 b40 b32 b24 b16 b8
   * </pre></code>
   *
   * @param value the long value to write.
   */
  void writeLong(int value) {
    int offset = _offset;

    if (SIZE <= offset + 16) {
      flushBuffer();
      offset = _offset;
    }

    if (LONG_DIRECT_MIN <= value && value <= LONG_DIRECT_MAX) {
      _byteData.setUint8(offset++, value + BC_LONG_ZERO);
    }
    else if (LONG_BYTE_MIN <= value && value <= LONG_BYTE_MAX) {
      _byteData.setUint8(offset++, BC_LONG_BYTE_ZERO + (value >> 8));
      _byteData.setUint8(offset++, value);
    } else if (LONG_SHORT_MIN <= value && value <= LONG_SHORT_MAX) {
      _byteData.setUint8(offset++, BC_LONG_SHORT_ZERO + (value >> 16));
      _byteData.setUint8(offset++, value >> 8);
      _byteData.setUint8(offset++, value);
    } else if (-0x80000000 <= value && value <= 0x7fffffff) {
      _byteData.setUint8(offset + 0, BC_LONG_INT);
//    _byteData.setUint8(offset + 1, (value >> 24));
//    _byteData.setUint8(offset + 2, (value >> 16));
//    _byteData.setUint8(offset + 3, (value >> 8));
//    _byteData.setUint8(offset + 4, value);
      _byteData.setUint32(offset + 1, value);
      offset += 5;
    } else {
      _byteData.setUint8(offset + 0, 76); //L
//    _byteData.setUint8(offset + 1, (value >> 56));
//    _byteData.setUint8(offset + 2, (value >> 48));
//    _byteData.setUint8(offset + 3, (value >> 40));
//    _byteData.setUint8(offset + 4, (value >> 32));
//    _byteData.setUint8(offset + 5, (value >> 24));
//    _byteData.setUint8(offset + 6, (value >> 16));
//    _byteData.setUint8(offset + 7, (value >> 8));
//    _byteData.setUint8(offset + 8, value);
      _byteData.setUint64(offset + 1, value);
      offset += 9;
    }

    _offset = offset;
  }

  /**
   * Writes a double value to the stream.  The double will be written
   * with the following syntax:
   *
   * <code><pre>
   * D b64 b56 b48 b40 b32 b24 b16 b8
   * </pre></code>
   *
   * @param value the double value to write.
   */
  void writeDouble(double value) {
    int offset = _offset;

    if (SIZE <= offset + 16) {
      flushBuffer();
      offset = _offset;
    }

    int intValue = value.toInt();

    if (intValue == value) {
      if (intValue == 0) {
        _byteData.setUint8(offset++, BC_DOUBLE_ZERO);

        _offset = offset;

        return;
      } else if (intValue == 1) {
        _byteData.setUint8(offset++, BC_DOUBLE_ONE);

        _offset = offset;

        return;
      } else if (-0x80 <= intValue && intValue < 0x80) {
        _byteData.setUint8(offset++, BC_DOUBLE_BYTE);
        _byteData.setUint8(offset++, intValue);

        _offset = offset;

        return;
      } else if (-0x8000 <= intValue && intValue < 0x8000) {
        _byteData.setUint8(offset + 0, BC_DOUBLE_SHORT);
        _byteData.setUint8(offset + 1, (intValue >> 8));
        _byteData.setUint8(offset + 2, intValue);

        _offset = offset + 3;

        return;
      }
    }

    int mills = (value * 1000).toInt();

    if (0.001 * mills == value) {
      _byteData.setUint8(offset + 0, BC_DOUBLE_MILL);
      _byteData.setUint8(offset + 1, (mills >> 24));
      _byteData.setUint8(offset + 2, (mills >> 16));
      _byteData.setUint8(offset + 3, (mills >> 8));
      _byteData.setUint8(offset + 4, mills);
      _offset = offset + 5;

      return;
    }

//long bits = Double.doubleToLongBits(value);

//buffer[offset + 0] = (byte) 'D';
//buffer[offset + 1] = (byte) (bits >> 56);
//buffer[offset + 2] = (byte) (bits >> 48);
//buffer[offset + 3] = (byte) (bits >> 40);
//buffer[offset + 4] = (byte) (bits >> 32);
//buffer[offset + 5] = (byte) (bits >> 24);
//buffer[offset + 6] = (byte) (bits >> 16);
//buffer[offset + 7] = (byte) (bits >> 8);
//buffer[offset + 8] = (byte) (bits);

    _byteData.setUint8(offset + 0, 68); //D
    _byteData.setFloat64(offset + 1, value);

    _offset = offset + 9;
  }

  /**
   * Writes a date to the stream.
   *
   * <code><pre>
   * date ::= d   b7 b6 b5 b4 b3 b2 b1 b0
   *      ::= x65 b3 b2 b1 b0
   * </pre></code>
   *
   * @param time the date in milliseconds from the epoch in UTC
   */
  void writeUTCDate(DateTime dateTime) {
    if (SIZE < _offset + 32)
      flushBuffer();

    int offset = _offset;

    int time = dateTime.millisecondsSinceEpoch;

    if (time % 60000 == 0) {
// compact date ::= x65 b3 b2 b1 b0

      int minutes = time ~/ 60000;

      if ((minutes >> 31) == 0 || (minutes >> 31) == -1) {
        _byteData.setUint8(offset + 0, BC_DATE_MINUTE);
        _byteData.setUint32(offset + 1, time);
//      _byteData.setUint8(offset + 1, (time >> 24));
//      _byteData.setUint8(offset + 2, (time >> 16));
//      _byteData.setUint8(offset + 3, (time >> 8));
//      _byteData.setUint8(offset + 4, (time >> 0));
        offset += 5;
        _offset = offset;
        return;
      }
    }

    _byteData.setUint8(offset + 0, BC_DATE);
    _byteData.setUint64(offset + 1, time);
//  _byteData.setUint8(offset + 1, (time >> 56));
//  _byteData.setUint8(offset + 2, (time >> 48));
//  _byteData.setUint8(offset + 3, (time >> 40));
//  _byteData.setUint8(offset + 4, (time >> 32));
//  _byteData.setUint8(offset + 5, (time >> 24));
//  _byteData.setUint8(offset + 6, (time >> 16));
//  _byteData.setUint8(offset + 7, (time >> 8));
//  _byteData.setUint8(offset + 8, time);
    offset += 9;

    _offset = offset;
  }

  /**
   * Writes a null value to the stream.
   * The null will be written with the following syntax
   *
   * <code><pre>
   * N
   * </pre></code>
   *
   * @param value the string value to write.
   */
  void writeNull() {
    int offset = _offset;

    if (SIZE <= offset + 16) {
      flushBuffer();
      offset = _offset;
    }

    _byteData.setUint8(offset++, 78);

    _offset = offset;
  }

  /**
   * Writes a string value to the stream using UTF-8 encoding.
   * The string will be written with the following syntax:
   *
   * <code><pre>
   * S b16 b8 string-value
   * </pre></code>
   *
   * If the value is null, it will be written as
   *
   * <code><pre>
   * N
   * </pre></code>
   *
   * @param value the string value to write.
   */
  void writeString(String value) {
    int offset = _offset;

    if (SIZE <= offset + 16) {
      flushBuffer();
      offset = _offset;
    }

    if (value == null) {
      _byteData.setUint8(offset++, 78); //N
      _offset = offset;
    }
    else {
      int length = value.length;
      int strOffset = 0;

      while (length > 0x8000) {
        int sublen = 0x8000;

        offset = _offset;

        if (SIZE <= offset + 16) {
          flushBuffer();
          offset = _offset;
        }

// chunk can't end in high surrogate
//char tail = value.charAt(strOffset + sublen - 1);
        int tail = value.codeUnitAt(strOffset + sublen - 1);

        if (0xd800 <= tail && tail <= 0xdbff)
          sublen--;

        _byteData.setUint8(offset + 0, BC_STRING_CHUNK);
        _byteData.setUint8(offset + 1, (sublen >> 8));
        _byteData.setUint8(offset + 2, sublen);

        _offset = offset + 3;

        printString3(value, strOffset, sublen);

        length -= sublen;
        strOffset += sublen;
      }

      offset = _offset;

      if (SIZE <= offset + 16) {
        flushBuffer();
        offset = _offset;
      }

      if (length <= STRING_DIRECT_MAX) {
        _byteData.setUint8(offset++, BC_STRING_DIRECT + length);
      }
      else if (length <= STRING_SHORT_MAX) {
        _byteData.setUint8(offset++, (BC_STRING_SHORT + (length >> 8)));
        _byteData.setUint8(offset++, length);
      }
      else {
        _byteData.setUint8(offset++, 83); //S
        _byteData.setUint8(offset++, (length >> 8));
        _byteData.setUint8(offset++, length);
      }

      _offset = offset;

      printString3(value, strOffset, length);
    }
  }

  ///**
// * Writes a string value to the stream using UTF-8 encoding.
// * The string will be written with the following syntax:
// *
// * <code><pre>
// * S b16 b8 string-value
// * </pre></code>
// *
// * If the value is null, it will be written as
// *
// * <code><pre>
// * N
// * </pre></code>
// *
// * @param value the string value to write.
// */
//void writeString(char []buffer, int offset, int length)
//
//{
//if (buffer == null) {
//if (SIZE < _offset + 16)
//flushBuffer();
//
//_buffer[_offset++] = (byte) ('N');
//}
//else {
//while (length > 0x8000) {
//int sublen = 0x8000;
//
//if (SIZE < _offset + 16)
//flushBuffer();
//
//// chunk can't end in high surrogate
//char tail = buffer[offset + sublen - 1];
//
//if (0xd800 <= tail && tail <= 0xdbff)
//sublen--;
//
//_buffer[_offset++] = (byte) BC_STRING_CHUNK;
//_buffer[_offset++] = (byte) (sublen >> 8);
//_buffer[_offset++] = (byte) (sublen);
//
//printString(buffer, offset, sublen);
//
//length -= sublen;
//offset += sublen;
//}
//
//if (SIZE < _offset + 16)
//flushBuffer();
//
//if (length <= STRING_DIRECT_MAX) {
//_buffer[_offset++] = (byte) (BC_STRING_DIRECT + length);
//}
//else if (length <= STRING_SHORT_MAX) {
//_buffer[_offset++] = (byte) (BC_STRING_SHORT + (length >> 8));
//_buffer[_offset++] = (byte) length;
//}
//else {
//_buffer[_offset++] = (byte) ('S');
//_buffer[_offset++] = (byte) (length >> 8);
//_buffer[_offset++] = (byte) (length);
//}
//
//printString(buffer, offset, length);
//}
//}
//
  /**
   * Writes a byte array to the stream.
   * The array will be written with the following syntax:
   *
   * <code><pre>
   * B b16 b18 bytes
   * </pre></code>
   *
   * If the value is null, it will be written as
   *
   * <code><pre>
   * N
   * </pre></code>
   *
   * @param value the string value to write.
   */
  void writeBytes(Uint8List buffer) {
    if (buffer == null) {
      if (SIZE < _offset + 16)
        flushBuffer();

      _byteData.setUint8(_offset++, 78); //N
    }
    else
      writeBytes3(buffer, 0, buffer.length);
  }

  /**
   * Writes a byte array to the stream.
   * The array will be written with the following syntax:
   *
   * <code><pre>
   * B b16 b18 bytes
   * </pre></code>
   *
   * If the value is null, it will be written as
   *
   * <code><pre>
   * N
   * </pre></code>
   *
   * @param value the string value to write.
   */
  void writeBytes3(Uint8List buffer, int offset, int length) {
    if (buffer == null) {
      if (SIZE < _offset + 16)
        flushBuffer();

      _byteData.setUint8(_offset++, 78); //N
    }
    else {
      while (SIZE - _offset - 3 < length) {
        int sublen = SIZE - _offset - 3;

        if (sublen < 16) {
          flushBuffer();

          sublen = SIZE - _offset - 3;

          if (length < sublen)
            sublen = length;
        }

        _byteData.setUint8(_offset++, BC_BINARY_CHUNK);
        _byteData.setUint8(_offset++, (sublen >> 8));
        _byteData.setUint8(_offset++, sublen);

        _buffer.setRange(_offset, _offset + sublen, buffer, offset);
        _offset += sublen;

        length -= sublen;
        offset += sublen;

        flushBuffer();
      }

      if (SIZE < _offset + 16)
        flushBuffer();

      if (length <= BINARY_DIRECT_MAX) {
        _byteData.setUint8(_offset++, (BC_BINARY_DIRECT + length));
      }
      else if (length <= BINARY_SHORT_MAX) {
        _byteData.setUint8(_offset++, (BC_BINARY_SHORT + (length >> 8)));
        _byteData.setUint8(_offset++, length);
      }
      else {
        _byteData.setUint8(_offset++, 66); //B
        _byteData.setUint8(_offset++, (length >> 8));
        _byteData.setUint8(_offset++, length);
      }

      _buffer.setRange(_offset, _offset + length, buffer, offset);

      _offset += length;
    }
  }

  ///**
// * Writes a byte buffer to the stream.
// *
// * <code><pre>
// * </pre></code>
// */
//void writeByteBufferStart()
//
//{
//}
//
  ///**
// * Writes a byte buffer to the stream.
// *
// * <code><pre>
// * b b16 b18 bytes
// * </pre></code>
// */
//void writeByteBufferPart(byte []buffer, int offset, int length)
//
//{
//while (length > 0) {
//flushIfFull();
//
//int sublen = _buffer.length - _offset;
//
//if (length < sublen)
//sublen = length;
//
//_buffer[_offset++] = BC_BINARY_CHUNK;
//_buffer[_offset++] = (byte) (sublen >> 8);
//_buffer[_offset++] = (byte) sublen;
//
//System.arraycopy(buffer, offset, _buffer, _offset, sublen);
//
//_offset += sublen;
//length -= sublen;
//offset += sublen;
//}
//}
//
  ///**
// * Writes a byte buffer to the stream.
// *
// * <code><pre>
// * b b16 b18 bytes
// * </pre></code>
// */
//void writeByteBufferEnd(byte []buffer, int offset, int length)
//
//{
//writeBytes(buffer, offset, length);
//}
//
  ///**
// * Returns an output stream to write binary data.
// */
//OutputStream getBytesOutputStream()
//
//{
//return new BytesOutputStream();
//}
//
  ///**
// * Writes a full output stream.
// */
//
//void writeByteStream(InputStream is)
//
//{
//while (true) {
//int len = SIZE - _offset - 3;
//
//if (len < 16) {
//flushBuffer();
//len = SIZE - _offset - 3;
//}
//
//len = is.read(_buffer, _offset + 3, len);
//
//if (len <= 0) {
//_buffer[_offset++] = BC_BINARY_DIRECT;
//return;
//}
//
//_buffer[_offset + 0] = (byte) BC_BINARY_CHUNK;
//_buffer[_offset + 1] = (byte) (len >> 8);
//_buffer[_offset + 2] = (byte) (len);
//
//_offset += len + 3;
//}
//}
//
  /**
   * Writes a reference.
   *
   * <code><pre>
   * x51 &lt;int>
   * </pre></code>
   *
   * @param value the integer value to write.
   */

  void writeRef(int value) {
    if (SIZE < _offset + 16)
      flushBuffer();

    _byteData.setUint8(_offset++, BC_REF);

    writeInt(value);
  }

  /**
   * If the object has already been written, just write its ref.
   *
   * @return true if we're writing a ref.
   */

  bool addRef(Object object) {
    if (_isUnshared) {
      _refCount++;
      return false;
    }

    int newRef = _refCount;

    int ref = addRef3(object, newRef, false);

    if (ref != newRef) {
      writeRef(ref);

      return true;
    }
    else {
      _refCount++;

      return false;
    }
  }


  int getRef(Object obj) {
    if (_isUnshared)
      return -1;

    return _refs.get(obj);
  }

  /**
   * Removes a reference.
   */
  bool removeRef(Object obj) {
    if (_isUnshared) {
      return false;
    }
    else if (_refs != null) {
      _refs.remove(obj);

      return true;
    }
    else
      return false;
  }

  /**
   * Replaces a reference from one object to another.
   */
  bool replaceRef(Object oldRef, Object newRef) {
    if (_isUnshared) {
      return false;
    }

    int value = _refs.get(oldRef);

    if (value >= 0) {
      addRef3(newRef, value, true);

      _refs.remove(oldRef);

      return true;
    }
    else
      return false;
  }

  int addRef3(Object value, int newRef, bool isReplace) {
    int prevRef = _refs.put(value, newRef, isReplace);

    return prevRef;
  }

  ///**
// * Starts the streaming message
// *
// * <p>A streaming message starts with 'P'</p>
// *
// * <pre>
// * P x02 x00
// * </pre>
// */
//void writeStreamingObject(Object obj)
//
//{
//startPacket();
//
//writeObject(obj);
//
//endPacket();
//}
//
  ///**
// * Starts a streaming packet
// *
// * <p>A streaming contains a set of chunks, ending with a zero chunk.
// * Each chunk is a length followed by data where the length is
// * encoded by (b1xxxxxxxx)* b0xxxxxxxx</p>
// */
//void startPacket()
//
//{
//if (_refs != null) {
//_refs.clear();
//_refCount = 0;
//}
//
//flushBuffer();
//
//_isPacket = true;
//_offset = 4;
//_buffer[0] = (byte) 0x05; // 0x05 = binary
//_buffer[1] = (byte) 0x55;
//_buffer[2] = (byte) 0x55;
//_buffer[3] = (byte) 0x55;
//}
//
//void endPacket()
//
//{
//int offset = _offset;
//
//OutputStream os = _os;
//
//if (os == null) {
//_offset = 0;
//return;
//}
//
//int len = offset - 4;
//
//if (len < 0x7e) {
//_buffer[2] = _buffer[0];
//_buffer[3] = (byte) (len);
//} else {
//_buffer[1] = (byte) (0x7e);
//_buffer[2] = (byte) (len >> 8);
//_buffer[3] = (byte) (len);
//}
//
//_isPacket = false;
//_offset = 0;
//
//if (os == null) {
//}
//else if (len < 0x7e) {
//os.write(_buffer, 2, offset - 2);
//}
//else {
//os.write(_buffer, 0, offset);
//}
//}

  ///**
// * Prints a string to the stream, encoded as UTF-8 with preceeding length
// *
// * @param v the string to print.
// */
//void printLenString(String v)
//
//{
//if (SIZE < _offset + 16)
//flushBuffer();
//
//if (v == null) {
//_buffer[_offset++] = (byte) (0);
//_buffer[_offset++] = (byte) (0);
//}
//else {
//int len = v.length();
//_buffer[_offset++] = (byte) (len >> 8);
//_buffer[_offset++] = (byte) (len);
//
//printString(v, 0, len);
//}
//}
//
  /**
   * Prints a string to the stream, encoded as UTF-8
   *
   * @param v the string to print.
   */
  void printString(String v) {
    printString3(v, 0, v.length);
  }

  /**
   * Prints a string to the stream, encoded as UTF-8
   *
   * @param v the string to print.
   */
  void printString3(String v, int strOffset, int length) {
    int offset = _offset;

    for (int i = 0; i < length; i++) {
      if (SIZE <= offset + 16) {
        _offset = offset;
        flushBuffer();
        offset = _offset;
      }

//char ch = v.charAt(i + strOffset);
      int ch = v.codeUnitAt(i + strOffset);

      if (ch < 0x80)
        _byteData.setUint8(offset++, ch);
      else if (ch < 0x800) {
        _byteData.setUint8(offset++, (0xc0 + ((ch >> 6) & 0x1f)));
        _byteData.setUint8(offset++, (0x80 + (ch & 0x3f)));
      }
      else {
        _byteData.setUint8(offset++, (0xe0 + ((ch >> 12) & 0xf)));
        _byteData.setUint8(offset++, (0x80 + ((ch >> 6) & 0x3f)));
        _byteData.setUint8(offset++, (0x80 + (ch & 0x3f)));
      }
    }

    _offset = offset;
  }

  ///**
// * Prints a string to the stream, encoded as UTF-8
// *
// * @param v the string to print.
// */
//void printString(char []v, int strOffset, int length)
//
//{
//int offset = _offset;
//byte []buffer = _buffer;
//
//for (int i = 0; i < length; i++) {
//if (SIZE <= offset + 16) {
//_offset = offset;
//flushBuffer();
//offset = _offset;
//}
//
//char ch = v[i + strOffset];
//
//if (ch < 0x80)
//buffer[offset++] = (byte) (ch);
//else if (ch < 0x800) {
//buffer[offset++] = (byte) (0xc0 + ((ch >> 6) & 0x1f));
//buffer[offset++] = (byte) (0x80 + (ch & 0x3f));
//}
//else {
//buffer[offset++] = (byte) (0xe0 + ((ch >> 12) & 0xf));
//buffer[offset++] = (byte) (0x80 + ((ch >> 6) & 0x3f));
//buffer[offset++] = (byte) (0x80 + (ch & 0x3f));
//}
//}
//
//_offset = offset;
//}
//
  void flushIfFull() {
    int offset = _offset;

    if (SIZE < offset + 32) {
      flushBuffer();
    }
  }

  void flush() {
    flushBuffer();

    //TODO:XXXX
//  if (_os != null)
//    _os.flush();
  }

  void flushBuffer() {
    int offset = _offset;

    if (!_isPacket && offset > 0) {
      ChunkBlock2 chunkBlock = new ChunkBlock2()..bytesLen = offset;

      if (offset + 32 >= SIZE) {
        chunkBlock.buffer = _buffer;
        _buffer = new Uint8List(SIZE);
        _byteData = new ByteData.view(_buffer.buffer);
      } else {
        chunkBlock.buffer = new Uint8List.fromList(_buffer.buffer.asUint8List(0, offset));
//        chunkBlock.buffer = _buffer.sublist(0, offset);
      }

      _chunkBlocks.add(chunkBlock);
      _totalBytes += offset;
      _offset = 0;
    } else if (_isPacket && offset > 4) {
      int len = offset - 4;

      _byteData.setUint8(0, _byteData.getUint8(0) | 0x80);
      _byteData.setUint8(1, 0x7e);
      _byteData.setUint8(2, len >> 8);
      _byteData.setUint8(3, len);


      ChunkBlock2 chunkBlock = new ChunkBlock2()..bytesLen = offset;
      if (offset + 32 >= SIZE) {
        chunkBlock.buffer = _buffer;
        _buffer = new Uint8List(SIZE);
        _byteData = new ByteData.view(_buffer.buffer);
      } else {
        chunkBlock.buffer = new Uint8List.fromList(_buffer.buffer.asUint8List(0, offset));
//        chunkBlock.buffer = _buffer.sublist(0, offset);
      }
      _chunkBlocks.add(chunkBlock);
      _totalBytes += offset;
      _offset = 4;

      _byteData.setUint8(0, 0x00);
      _byteData.setUint8(1, 0x56);
      _byteData.setUint8(2, 0x56);
      _byteData.setUint8(3, 0x56);
    }
  }


  void close() {
// hessian/3a8c
    flush();
  }

  void free() {
    reset();
  }

  /**
   * Resets the references for streaming.
   */
  void resetReferences() {
    if (_refs != null) {
      _refs.clear();
      _refCount = 0;
    }
  }

  /**
   * Resets all counters and references
   */
  void reset() {
    if (_refs != null) {
      _refs.clear();
      _refCount = 0;
    }

    _classRefs.clear();
    _typeRefs = null;
    _offset = 0;
    _isPacket = false;
    _isUnshared = false;

    _chunkBlocks.clear();
    _totalBytes = 0;
  }

  Uint8List toBuffer() {
    if (_chunkBlocks.isEmpty) {
      return null;
    }

    if (_chunkBlocks.length == 1) {
      if (_chunkBlocks[0].bytesLen == _chunkBlocks[0].buffer.length) {
        return _chunkBlocks[0].buffer;
      }
      return _chunkBlocks[0].buffer.buffer.asUint8List(0, _chunkBlocks[0].bytesLen);
//      return _chunkBlocks[0].buffer.sublist(0, _chunkBlocks[0].bytesLen);
    }

    int chunkOffset = 0;
    Uint8List data = new Uint8List(_totalBytes);
    _chunkBlocks.forEach((e) {
      data.setRange(chunkOffset, chunkOffset + e.bytesLen, e.buffer);
      chunkOffset += e.bytesLen;
    });
    return data;
  }
}

Hessian2Output hoGlobal = new Hessian2Output();