export 'package:saker/framework/jsonserializer/utils.dart';

//通过Dart类型获取
dynamic getMType(dynamic v) {
  if (v == null) {
    return -1;
  }
  if (v is int) {
    return 7;
  }
  if (v is double) {
    return 9;
  }
  if (v is String) {
    return 14;
  }

  if (v is List) {
    return 15;
  }
  if (v is Set) {
    return 17;
  }
  if (v is Map) {
    return 18;
  }

  if (v is bool) {
    return 1;
  }
  if (v is DateTime) {
    return 13;
  }
  if (v is DObjectBase) {
    return v.getRType();
  }
  return 99;
}

dynamic makePair(dynamic value, dynamic type) {
  if (value == null) {
    return null;
  }
  //Discard Object type
  if (type is String && type == r'java.lang.Object') {
    return null;
  }
  return {
    't': type,
    'v': value
  };
}

dynamic makePairParameter(dynamic value, dynamic type) {
  return {
    't': type,
    'v': value
  };
}

dynamic makePairJson(dynamic value, dynamic type) {
//  //Discard Object type
//  if (type is String && type == r'java.lang.Object') {
//    return null;
//  }
  return value;
}

dynamic makePairMap(dynamic value, dynamic type, dynamic key_type) {
  if (value == null) {
    return null;
  }
  //Discard Object type
  if (type is String && type == r'java.lang.Object') {
    return null;
  }
  if (key_type is String && key_type == r'java.lang.Object') {
      return null;
  }
  return {
    't': type,
    'v': value,
    'kt': key_type,
  };
}

dynamic makePairMapParameter(dynamic value, dynamic type, dynamic key_type) {
  return {
    't': type,
    'v': value,
    'kt': key_type,
  };
}

dynamic makePairMapJson(dynamic value, dynamic type, dynamic key_type) {
//  //Discard Object type
//  if (type is String && type == r'java.lang.Object') {
//    return null;
//  }
  if (key_type is String && key_type == r'java.lang.Object') {
      return null;
  }
  return value;
}

const int HSF_ERROR_SUCC = 0;
const int HSF_ERROR_PARAMS_ERROR = -1;
const int HSF_ERROR_SERVER = -2;
const int HSF_ERROR_CONSUMER_NOT_FOUND = -3;
const int HSF_ERROR_APP_ERROR = -4;
const int HSF_ERROR_UNKNOWN_EXCEPTION = -5;
const int HSF_ERROR_ISOLATE_NULL = -6;
const int HSF_ERROR_CALLBACK = -8;
const int HSF_ERROR_TIMEOUT = -9;

typedef dynamic generic_new_func(dynamic v);

abstract class DObjectBase {
  void fromJson(Map<dynamic, dynamic> json, {Map<String, generic_new_func> genericNewMap});

  Map<String, dynamic> toHessianJson();
  dynamic toJson();

  String getRType();
}

class DObjectResult {
  int err_code = HSF_ERROR_SUCC;
  String err_msg;

  bool get success => err_code == HSF_ERROR_SUCC;
}

