import 'package:saker/framework/log/log.dart';
import 'package:saker/framework/jproxy_status/plugin_base.dart';

class PluginManager {
  Map<String, ProxyPluginBase> plugins = {};

  static PluginManager _pluginManager;

  static PluginManager getInstance() {
    if (_pluginManager == null) {
      _pluginManager = new PluginManager();
    }
    return _pluginManager;
  }

  void register(ProxyPluginBase plugin) {
    MyLogger.getDebugLogger()?.debug("Plugin Register: ${plugin.getName()}  status:${plugin.getStatus()}");
    plugins[plugin.getName()] = plugin;
  }

  bool getStatus() {
    for (ProxyPluginBase plugin in plugins.values) {
      MyLogger.getDebugLogger()?.debug("Plugin Status: ${plugin.getName()}  --> ${plugin.getStatus()}");
      if (!plugin.getStatus()) {
        return false;
      }
    }
    return true;
  }
}