import 'package:saker/framework/jsonserializer/utils.dart';

abstract class ProtoBase extends JsonBase {
}

abstract class ApiRequestBase extends ProtoBase {
  String get apiName;
  String get apiVersion;
  bool get apiMsgType;
  bool get needAuth;
  Map<String, dynamic> get apiParams;
  dynamic parseResponse(Map<dynamic, dynamic> json);
  Map<String, dynamic> requestContext;
}

abstract class ApiResponseBase extends ProtoBase {
}

abstract class CardBase extends ProtoBase {
  int get cardType;
  dynamic get cardData;
}

abstract class CardItemsContainer extends ProtoBase {
}

//分页请求
abstract class PageRequest {
  int getPageSize();

  void setPageSize(int pageSize);

  int getPageNumber();

  void setPageNumber(int pageNumber);
}

abstract class PageResponse {
  bool getHasMore();
}
