// Generated by IdleFish Protocol CodeGenerator,MD5:F1DAFE7D9003FE0DA23F1E1093E06BC0
// 这是根据协议自动生成的文件，你可以修改这个文件
// 修改以后，协议生成将不会再自动更新这个文件

//JSON参数
import 'dart:convert';

import 'package:saker/framework/hsf/hsf_object_base.dart';

class JsonAnnotation {
  const JsonAnnotation();
}

class ProtoJsonAnnotation {
  final bool transient;
  const ProtoJsonAnnotation({this.transient = false});
}

// 注册Card类型
class ProtoCardAnnotation {
  //cardTypes中的类型都对应到这个数据结构
  final List<int> cardTypes;
  //在Card容器里CardData是一个数组，解析到这个Card的items字段
  final bool arrayContainer;
  const ProtoCardAnnotation({this.cardTypes, this.arrayContainer = false});
}

// 分页请求
class ProtoPageAnnotation {
  final int pageNumber;
  final int pageSize;
  const ProtoPageAnnotation({this.pageNumber, this.pageSize});
}

abstract class JsonBase {
  Map<String, dynamic> toJson();
}

class JsonUtil {
  static String parseString(dynamic v) {
    return v == null ? null : (v is String ? v : v.toString());
  }

  static int parseInt(dynamic v) {
    return v == null ? null : (v is int ? v : int.tryParse(v.toString())??0);
  }

  static double parseDouble(dynamic v) {
    return v == null ? null : (v is double ? v : double.tryParse(v.toString())??0.0);
  }

  static bool parseBool(dynamic v) {
    return v == null ? null : (v is bool ? v : (v == 'true' || v == 1));
  }

  static DateTime parseDateTime(dynamic v) {
    if (v == null) {
      return null;
    }
    if (v is DateTime) {
      return v;
    }
    if (v is int) {
      return new DateTime.fromMillisecondsSinceEpoch(v);
    }
    if (v is String) {
      return DateTime.tryParse(v);
    }
    throw new Exception('ParseDateTime error, v=${v}, type=${v.runtimeType}');
  }

  static dynamic translateDynamic(dynamic c) {
    if (c == null) {
      return null;
    }
    if (c is JsonBase || c is DObjectBase) {
      return c.toJson();
    }
    if (c is Map) {
      return new Map<dynamic, dynamic>.fromIterables(c.keys.map<dynamic>((dynamic e) => translateDynamic(e)).toList(), c.values.map<dynamic>((dynamic e) => translateDynamic(e)).toList());
    }
    if (c is List) {
      return c.map<dynamic>((dynamic e) => translateDynamic(e))?.toList();
    }
    return c;
  }

  static dynamic translateMTOP(dynamic o) {
    if (o == null) {
      return null;
    }
    if (o is String) {
      return o;
    }
    if (o is JsonBase || o is DObjectBase) {
      return translateMTOP(o.toJson());
    }
    if (o is int || o is double || o is bool) {
      return o.toString();
    }
    if (o is Map) {
      return new Map<String, dynamic>.fromIterables(o.keys.cast(), o.values.map((v) => translateMTOP(v)));
    }
    if (o is Iterable) {
      return o.map((v) => translateMTOP(v)).toList();
    }
    if (o is DateTime) {
      return DateUtils.formatDateTime(o);
    }
    return o.toString();
  }

  static dynamic jsonStringEncoder(dynamic o) {
    if (o == null) {
      return null;
    }
    if (o is String) {
      return o;
    }
    if (o is int || o is double || o is bool) {
      return o.toString();
    }
    if (o is DateTime) {
      return DateUtils.formatDateTime(o);
    }
    if (o is JsonBase || o is DObjectBase) {
      return translateMTOP(o);
    }
    return o;
  }

  static dynamic jsonEncoder(dynamic o) {
    if (o == null) {
      return null;
    }
    if (o is DateTime) {
      return o.millisecondsSinceEpoch;
    }
    if (o is JsonBase || o is DObjectBase) {
      return translateDynamic(o);
    }
    return o;
  }

  static String encode(dynamic obj) {
    return json.encode(obj, toEncodable: jsonEncoder);
  }

  static String encodeMTOP(dynamic obj) {
    return json.encode(obj, toEncodable: jsonStringEncoder);
  }

  static T decode<T>(String jsonStr) {
    if (jsonStr == null || jsonStr.isEmpty) {
      return null;
    }
    dynamic o = json.decode(jsonStr);
    if (o == null) {
      return null;
    }
    if (o is T) {
      return o;
    }
    throw new Exception('Json decode error: str=${jsonStr} val=${o} type=${o.runtimeType}');
  }
}

//向前兼容代码
class ProtoUtil {
  static String parseString(dynamic v) {
    return JsonUtil.parseString(v);
  }

  static int parseInt(dynamic v) {
    return JsonUtil.parseInt(v);
  }

  static double parseDouble(dynamic v) {
    return JsonUtil.parseDouble(v);
  }

  static bool parseBool(dynamic v) {
    return JsonUtil.parseBool(v);
  }

  static DateTime parseDateTime(dynamic v) {
    return JsonUtil.parseDateTime(v);
  }

  static dynamic translateDynamic(dynamic c) {
    return JsonUtil.translateDynamic(c);
  }

  static dynamic translateMTOP(dynamic o) {
    return JsonUtil.translateMTOP(o);
  }
}

class DateUtils {
  static String _twoDigits(int n) {
    if (n >= 10) return '${n}';
    return '0${n}';
  }

  static String _fourDigits(int n) {
    int absN = n.abs();
    String sign = n < 0 ? '-' : '';
    if (absN >= 1000) return '$n';
    if (absN >= 100) return '${sign}0$absN';
    if (absN >= 10) return '${sign}00$absN';
    return '${sign}000$absN';
  }

  static String formatDateTime(DateTime dateTime) {
    if (dateTime == null) {
      return null;
    }

    String y = _fourDigits(dateTime.year);
    String m = _twoDigits(dateTime.month);
    String d = _twoDigits(dateTime.day);
    String h = _twoDigits(dateTime.hour);
    String min = _twoDigits(dateTime.minute);
    String sec = _twoDigits(dateTime.second);
    return '$y-$m-$d $h:$min:$sec';
  }

  static String formatDate(DateTime dateTime) {
    if (dateTime == null) {
      return null;
    }

    String y = _fourDigits(dateTime.year);
    String m = _twoDigits(dateTime.month);
    String d = _twoDigits(dateTime.day);
    return '$y-$m-$d';
  }

  static String formatTime(DateTime dateTime) {
    if (dateTime == null) {
      return null;
    }

    String h = _twoDigits(dateTime.hour);
    String min = _twoDigits(dateTime.minute);
    String sec = _twoDigits(dateTime.second);
    return '$h:$min:$sec';
  }
}

