import 'dart:async';
import 'dart:isolate';

import 'package:saker/framework/environment/env_base.dart';
import 'package:saker/framework/log/log.dart';
import 'package:saker/plugin/faas/container/src/df_platform_protocol.dart';
import 'package:saker/plugin/faas/ops/df_ops.dart';
import '../service_server.dart';
import 'src/grpc_server.dart';

Server _grpcServer;

class GrpcServerService extends AbstractServer{

  @override
  String get serverKind => GRPC;

  @override
  Future init(List<dynamic> param) {
    //DO NOTHING
  }

  @override
  void offline({SendPort sendPort, int eventId, int offline}) {
    //DO NOTHING
  }

  @override
  void shutdown({SendPort sendPort, int eventId}) {
    //DO NOTHING
  }

  @override
  Future close({String type, SendPort sendPort, int eventId}) async{
    if(_grpcServer!=null){
      _grpcServer.shutdown()
          .then((e){
        MyLogger.getLogger().warn("${this.serverId} - ${lc_svr_close_success} ");
      })
          .catchError((e,stackTrace){
        MyLogger.getLogger().error("${this.serverId} - ${lc_svr_close_failed} ${e} ${stackTrace}");

      });
    }
  }

  @override
  Future start({List<dynamic> param}) async{
    //grpc impl
     _grpcServer = Server([GaiaGrpcServiceProtocol(), GrpcOpsService()], [beforeCall]);
     _grpcServer.serve(address:EnvFramework.serverAddress, port: EnvFramework.serverPort,shared: true);
     return _grpcServer;
  }

}

