import 'dart:isolate';

import 'package:saker/framework/environment/env_base.dart';
import 'package:saker/framework/event/event_pool.dart';
import 'package:saker/framework/event/event_pool_base.dart';
import 'package:saker/framework/hsf/hsf_async.dart';
import 'package:saker/framework/services/service_var.dart';

EnvBase _hsfEnvBase;

//新开的Isolate
hsf_server_isolate_entry(List<dynamic> messages) async {
  try {
    print('${new DateTime.now().toString()} HSF provider isolate entry begin');

    _hsfEnvBase = messages[3] as EnvBase;
    _hsfEnvBase.init(messages[0] as String, "HSFProvider");
//    _hsfEnvBase.initIsolate();
    String _servicesRegister = messages[4] as String;

    mainEventPort = messages[1] as SendPort;
    int eventId = messages[2] as int;

    print('${new DateTime.now().toString()} HSF provider isolate entry env init ok');

    EnvBase.getEnv = () => _hsfEnvBase;

    mainEventPort.send([EventType_Any, eventId, EventStatus_OK, EventPool.sendPort]);

    hsf_create_provider(_servicesRegister);

    print('${new DateTime.now().toString()} HSF provider isolate entry end');
  } catch (e, stack) {
    print('${new DateTime.now().toString()} HSF provider isolate error: ${e}, ${stack}');
  }
}
