import 'package:saker/framework/hsf/hsf_object_base.dart';
import 'package:saker/framework/hessian/hessian1_output.dart';
import 'package:saker/framework/hessian/hessian2_output.dart';
import 'package:saker/framework/hessian/hessian_object_base.dart';

class DartHsfRpcContext implements HessianObjectBase {
  String imei;

  String imsi;

  int userId;

  String nick;

  String ttid;

  String ip;

  String proxyIp;

  String platform;

  String appName;

  String appVersion;

  String from;

  String sid;

  String appKey;

  String channelId;

  String deviceId;

  String lat;

  String lng;

  String uttid;

  String eagleeyeUserData;

  String sysEntrance;

  String nativeProxyH5;

  String getRType() {
    return r'com.taobao.idledomain.dto.dataobject.DartHsfRpcContext';
  }

  void fromJson(Map<String, dynamic> json, Map<String, generic_new_func> genericNewMap) {
    //从Map转成对象的实现
    imei = json['imei']?.toString();
    imsi = json['imsi']?.toString();
    userId = json['userId'] as int;
    nick = json['nick']?.toString();
    ttid = json['ttid']?.toString();
    ip = json['ip']?.toString();
    proxyIp = json['proxyIp']?.toString();
    platform = json['platform']?.toString();
    appName = json['appName']?.toString();
    appVersion = json['appVersion']?.toString();
    from = json['from']?.toString();
    sid = json['sid']?.toString();
    appKey = json['appKey']?.toString();
    channelId = json['channelId']?.toString();
    deviceId = json['deviceId']?.toString();
    lat = json['lat']?.toString();
    lng = json['lng']?.toString();
    uttid = json['uttid']?.toString();
    eagleeyeUserData = json['eagleeyeUserData']?.toString();
    sysEntrance = json['sysEntrance']?.toString();
    nativeProxyH5 = json['nativeProxyH5']?.toString();
  }

  Map<String, dynamic> toHessianJson() {
    Map<String, dynamic> val = {};

//    val.addAll(super.toHessianJson());

    void writeNotNull(String key, dynamic value) {
      if (value != null) {
        val[key] = value;
      }
    }

    writeNotNull('imei', makePair(imei,14));
    writeNotNull('imsi', makePair(imsi,14));
    writeNotNull('userId', makePair(userId,8));
    writeNotNull('nick', makePair(nick,14));
    writeNotNull('ttid', makePair(ttid,14));
    writeNotNull('ip', makePair(ip,14));
    writeNotNull('proxyIp', makePair(proxyIp,14));
    writeNotNull('platform', makePair(platform,14));
    writeNotNull('appName', makePair(appName,14));
    writeNotNull('appVersion', makePair(appVersion,14));
    writeNotNull('from', makePair(from,14));
    writeNotNull('sid', makePair(sid,14));
    writeNotNull('appKey', makePair(appKey,14));
    writeNotNull('channelId', makePair(channelId,14));
    writeNotNull('deviceId', makePair(deviceId,14));
    writeNotNull('lat', makePair(lat,14));
    writeNotNull('lng', makePair(lng,14));
    writeNotNull('uttid', makePair(uttid,14));
    writeNotNull('eagleeyeUserData', makePair(eagleeyeUserData,14));
    writeNotNull('sysEntrance', makePair(sysEntrance,14));
    writeNotNull('nativeProxyH5', makePair(nativeProxyH5,14));
    return val;
  }

  dynamic toJson() {
    Map<String, dynamic> val = {};

//    dynamic superVal = super.toJson();
//    if (superVal != null && superVal is Map<String, dynamic>) {
//      val.addAll(superVal);
//    }

    void writeNotNull(String key, dynamic value) {
      if (value != null) {
        val[key] = value;
      }
    }

    writeNotNull('imei', makePairJson(imei,14));
    writeNotNull('imsi', makePairJson(imsi,14));
    writeNotNull('userId', makePairJson(userId,8));
    writeNotNull('nick', makePairJson(nick,14));
    writeNotNull('ttid', makePairJson(ttid,14));
    writeNotNull('ip', makePairJson(ip,14));
    writeNotNull('proxyIp', makePairJson(proxyIp,14));
    writeNotNull('platform', makePairJson(platform,14));
    writeNotNull('appName', makePairJson(appName,14));
    writeNotNull('appVersion', makePairJson(appVersion,14));
    writeNotNull('from', makePairJson(from,14));
    writeNotNull('sid', makePairJson(sid,14));
    writeNotNull('appKey', makePairJson(appKey,14));
    writeNotNull('channelId', makePairJson(channelId,14));
    writeNotNull('deviceId', makePairJson(deviceId,14));
    writeNotNull('lat', makePairJson(lat,14));
    writeNotNull('lng', makePairJson(lng,14));
    writeNotNull('uttid', makePairJson(uttid,14));
    writeNotNull('eagleeyeUserData', makePairJson(eagleeyeUserData,14));
    writeNotNull('sysEntrance', makePairJson(sysEntrance,14));
    writeNotNull('nativeProxyH5', makePairJson(nativeProxyH5,14));
    return val;
  }

  @override
  void writeHessian1(Hessian1Output out, Map<String,generic_hessian_func> genericMap) {
    if (out.addRef(this)) {
      return;
    }
    out.writeObjectBegin(getRType());

    if (imei != null) {
      out.writeString('imei');
      out.writeObjectValue('java.lang.String', imei, null);
    }

    if (imsi != null) {
      out.writeString('imsi');
      out.writeObjectValue('java.lang.String', imsi, null);
    }

    if (userId != null) {
      out.writeString('userId');
      out.writeObjectValue('long', userId, null);
    }

    if (nick != null) {
      out.writeString('nick');
      out.writeObjectValue('java.lang.String', nick, null);
    }

    if (ttid != null) {
      out.writeString('ttid');
      out.writeObjectValue('java.lang.String', ttid, null);
    }

    if (ip != null) {
      out.writeString('ip');
      out.writeObjectValue('java.lang.String', ip, null);
    }

    if (proxyIp != null) {
      out.writeString('proxyIp');
      out.writeObjectValue('java.lang.String', proxyIp, null);
    }

    if (platform != null) {
      out.writeString('platform');
      out.writeObjectValue('java.lang.String', platform, null);
    }

    if (appName != null) {
      out.writeString('appName');
      out.writeObjectValue('java.lang.String', appName, null);
    }

    if (appVersion != null) {
      out.writeString('appVersion');
      out.writeObjectValue('java.lang.String', appVersion, null);
    }

    if (from != null) {
      out.writeString('from');
      out.writeObjectValue('java.lang.String', from, null);
    }

    if (sid != null) {
      out.writeString('sid');
      out.writeObjectValue('java.lang.String', sid, null);
    }

    if (appKey != null) {
      out.writeString('appKey');
      out.writeObjectValue('java.lang.String', appKey, null);
    }

    if (channelId != null) {
      out.writeString('channelId');
      out.writeObjectValue('java.lang.String', channelId, null);
    }

    if (deviceId != null) {
      out.writeString('deviceId');
      out.writeObjectValue('java.lang.String', deviceId, null);
    }

    if (lat != null) {
      out.writeString('lat');
      out.writeObjectValue('java.lang.String', lat, null);
    }

    if (lng != null) {
      out.writeString('lng');
      out.writeObjectValue('java.lang.String', lng, null);
    }

    if (uttid != null) {
      out.writeString('uttid');
      out.writeObjectValue('java.lang.String', uttid, null);
    }

    if (eagleeyeUserData != null) {
      out.writeString('eagleeyeUserData');
      out.writeObjectValue('java.lang.String', eagleeyeUserData, null);
    }

    if (sysEntrance != null) {
      out.writeString('sysEntrance');
      out.writeObjectValue('java.lang.String', sysEntrance, null);
    }

    if (nativeProxyH5 != null) {
      out.writeString('nativeProxyH5');
      out.writeObjectValue('java.lang.String', nativeProxyH5, null);
    }

    out.writeObjectEnd();
  }

  @override
  void writeHessian2(Hessian2Output out, Map<String,generic_hessian_func> genericMap) {
    if (out.addRef(this)) {
      return;
    }
    int ref = out.writeObjectBegin(getRType());
    if (ref == -1) {
      out.writeDefinition20(['imei' ,'imsi' ,'userId' ,'nick' ,'ttid' ,'ip' ,'proxyIp' ,'platform' ,'appName' ,'appVersion' ,'from' ,'sid' ,'appKey' ,'channelId' ,'deviceId' ,'lat' ,'lng' ,'uttid']);
      out.writeObjectBegin(getRType());
    }

    out.writeObjectValue('java.lang.String', imei, null);

    out.writeObjectValue('java.lang.String', imsi, null);

    out.writeObjectValue('long', userId, null);

    out.writeObjectValue('java.lang.String', nick, null);

    out.writeObjectValue('java.lang.String', ttid, null);

    out.writeObjectValue('java.lang.String', ip, null);

    out.writeObjectValue('java.lang.String', proxyIp, null);

    out.writeObjectValue('java.lang.String', platform, null);

    out.writeObjectValue('java.lang.String', appName, null);

    out.writeObjectValue('java.lang.String', appVersion, null);

    out.writeObjectValue('java.lang.String', from, null);

    out.writeObjectValue('java.lang.String', sid, null);

    out.writeObjectValue('java.lang.String', appKey, null);

    out.writeObjectValue('java.lang.String', channelId, null);

    out.writeObjectValue('java.lang.String', deviceId, null);

    out.writeObjectValue('java.lang.String', lat, null);

    out.writeObjectValue('java.lang.String', lng, null);

    out.writeObjectValue('java.lang.String', uttid, null);

    out.writeObjectValue('java.lang.String', eagleeyeUserData, null);

    out.writeObjectValue('java.lang.String', sysEntrance, null);

    out.writeObjectValue('java.lang.String', nativeProxyH5, null);

  }
}
