import 'dart:async';

import 'dart:convert';

class MtopContext {
  final Map<String, String> context;
  final Map<String, String> headers;

  MtopContext(this.context, this.headers);

  String toString(){
    return "MtopContext: context:${json.encode(context??{})}, headers:${json.encode(headers??{})}";
  }

  static MtopContext EMPTY = new MtopContext({}, {});

  //用户ID
  int get userId => context.containsKey('userId') ? int.tryParse(context['userId'])??0 : 0;

  //用户昵称
  String get userNick => context['nick'];

  //平台类型
  String get platform => context['platform'];

  //设备ID
  String get deviceId => context['deviceId'];

  String get ttid => context['ttid'];

  String get imei => context['imei'];

  String get imsi => context['imsi'];

  String get appkey => context['appkey'];

  // 设备唯一标识utdid
  String get utdid => context['utdid'];
  String get uttid => context['utdid'];// uttid就是utdid

  //中转前的客户端IP
  String get s2sClientIp => headers['s2sclientip'];

  String get appVersion => context['appVersion'];

  String get lat => context['lat'];

  String get lng => context['lng'];

  String get ip => context['ip'];
  String get appName => context['appName'];
  String get sid => context['sid'];

  String get from => headers["x-request-from"]??"";
  String get proxyIP => ""; //TODO

  //直连本机的IP
  String get directIP => headers['direct-ip'];

  bool isH5(){
    String value = context["sysEntrance"]?.toLowerCase();
    return value != null && "h5update" == value ||  "h5" == value ||  "bigpipe_h5" == value || "mtop4_h5" == value;
  }

  bool isNativeProxyH5() {
    String value = context["nativeProxyH5"]?.toLowerCase();
    return value == null || value == "true";
  }

  static MtopContext getZoneContext() {
    return (Zone.current[#MtopContext] as MtopContext) ?? MtopContext.EMPTY;
  }
}