import 'package:saker/framework/environment/env_base.dart';
import 'package:saker/framework/services/service_server.dart';
import 'package:saker/framework/services/service_var.dart';

EnvBase _serverEnvBase;


/*
 * new server entry
 *      EnvFramework.rootPath,
        eventItem.sendPort,
        eventItem.id,
        idx,
        getBizIsolatePorts(),
        EnvBase.getEnv()
 */
void worker_isolate_entry(List<dynamic> messages) async{
  print('${new DateTime.now().toString()}  main isolate entry ${messages[3]} begin');
  _serverEnvBase = messages[5] as EnvBase;
  _serverEnvBase.init(messages[0] as String, "MAIN${messages[3]}");
  print('${new DateTime.now().toString()}  server main isolate entry ${messages[3]} env init ok');
  EnvBase.getEnv = () => _serverEnvBase;

  preProcessing = _serverEnvBase.getPreProcessing();
  serviceEntries = _serverEnvBase.getServiceEntries();

  //calculate server kind
  try{
    processor = EnvFramework.serviceServerKind == GRPC ? ServerService.grpc() : ServerService.http();
    processor.start(param: messages);
  }catch(e,stack){
    print('${new DateTime.now().toString()} ${EnvFramework.serviceServerKind} server error isloate: ${e}, ${stack}');
  }
}
