import 'dart:io';
import 'dart:isolate';

import 'package:saker/framework/event/event_pool_base.dart';
import 'package:saker/framework/event/notice_type.dart';
import 'package:saker/framework/log/log.dart';
import 'package:saker/framework/services/service_base.dart';
import 'package:saker/framework/services/service_server.dart';
import 'package:saker/framework/jproxy_status/event_controller.dart';

final ContentType jsonContentType = ContentType("application", "json", charset: "utf-8");
SendPort mainEventPort = null;
AbstractServer processor = null;
Map<String, SendPort> bizIsolateMap = {};
Map<String, ServiceBase> serviceEntries = {};
Map<String, Processing> preProcessing = {};

int svcOfflineStatus = 1;

typedef Processing = Function  (HttpRequest request) ;


class EventControllerImpl implements EventController {
  static EventController eventController;
  static EventController getInstance() {
    if (eventController == null) {
      eventController = new EventControllerImpl();
    }
    return eventController;
  }

  @override
  void setOfflineAndChecking() {
    MyLogger.getLogger().error("setOfflineAndChecking: offline work isolate.");
    print('setOfflineAndChecking');
    mainEventPort?.send([EventType_Notice, [NoticeType.WorkerIsolateOffline, 1, 1]]);
  }
}