import 'dart:io';
import 'dart:math';

import 'package:saker/framework/environment/env_base.dart';
import 'package:saker/framework/environment/env_type.dart';
import 'package:saker/framework/log/log.dart';
import 'package:saker/framework/log/log_type.dart';
import 'package:saker/plugin/faas/common/instances.dart';
import 'package:saker/plugin/faas/container/conf/gaia_config.dart';

class ServiceMonitor{
  static Random random = new Random(new DateTime.now().millisecondsSinceEpoch);

  LogType logType;
  String userId;
  String userNick;
  String req;
  String res;
  String mtopPath;
  String reqMethod;

  String ttid;
  String traceId;
  String rpcId;

  String localIP;
  String remoteIP;
  int rt;
  int respSize;//resp json string length，如果业务设置了，框架不再覆盖

  bool success;
  String errCode;
  String extraMsg;

  void flush() {
    if (random.nextInt(100) < 10 || logType == LogType.MtopSvc || logType == LogType.HsfSvc || EnvFramework.env == ENV_PREPUB) {
      rt = new DateTime.now().millisecondsSinceEpoch - rt;

      if(EnvFramework.isFaaS ){ //Faas fuck最好能统一
        if(logType == LogType.MtopSvc){
          MyLogger.getLogger(name: "functionAccess")?.error(toFaasString());//该监控日志只输出了 外部请求的
        }

        mtopPath = "${functionName}|${functionVersion}";
        if(req != null && req.length > 128){
          req.substring(0,127);
        }
        if(res != null && res.length > 128){
          res.substring(0,127);
        }
        MyLogger.getLogger(name: "caiNiaoMonitor")?.error(toString());

      }else{//dart应用
        if(req != null && req.length > 128){
          req.substring(0,127);
        }
        if(res != null && res.length > 128){
          res.substring(0,127);
        }
        MyLogger.getLogger(name: "caiNiaoMonitor")?.error(toString());
      }

    }
  }

  String toString(){
    return "$traceId|$rpcId|$localIP|$remoteIP|$mtopPath|$reqMethod|$rt|"
        "${logType?.index}|$success|$errCode|$respSize|$ttid|$userId|$userNick|$req|$res|$extraMsg";
  }

  String toFaasString(){
    return '${Platform.localHostname}|${GaiaConfig.env}|${functionName}|${functionVersion}'
        '|DART|2.2|MTOP'
        '|${traceId}|${remoteIP}'
        '|${success}|${rt}|${errCode}|${respSize}|${req}|${res}';
  }
}
