
class TairResultCode {
  int code = 0;
  String message ;

  TairResultCode(int code, String message) {
    code = code;
    message = message;
  }

  static Map<int, TairResultCode> codeMap = {};
  static int serialVersionUID = 1;
  static TairResultCode SUCCESS = createTairResultCode(0, "success");
  static TairResultCode DATANOTEXSITS = createTairResultCode(1, "data not exist");
  static TairResultCode MEMBERNOTEXISTS = createTairResultCode(2, "member not exist");
  static TairResultCode HOTZONE_DATANOTEXSITS = new TairResultCode(3, "hotzone data not exist");
  static TairResultCode CONNERROR = createTairResultCode(-1, "connection error or timeout");
  static TairResultCode UNKNOW = createTairResultCode(-2, "unknown error. ensure storage engine (mdb, ldb) support the interface. see it in wiki");
  static TairResultCode KEYORVALUEISNULL = createTairResultCode(-3, "key or value is null");
  static TairResultCode KEYTOLARGE = createTairResultCode(-5, "key length error. key must less than 1k");
  static TairResultCode VALUETOLARGE = createTairResultCode(-6, "value length error. value must less than 1M");
  static TairResultCode NSERROR = createTairResultCode(-7, "namespace range error, should between 0 ~ 65535");
  static TairResultCode PARTSUCC = createTairResultCode(-10, "partly success. Some key request fails, through the returned value to know which key operation failed.");
  static TairResultCode ASYNCERR = createTairResultCode(-11, "async call failed, pool maybe full");
  static TairResultCode CLIENTHANDLERERR = createTairResultCode(-12, "multi cluster handler is null");
  static TairResultCode OVERFLOW = createTairResultCode(-13, "namespace overflow");
  static TairResultCode CLIENT_NOT_INITED = createTairResultCode(-14, "tair client not inited");
  static TairResultCode SERVERERROR = createTairResultCode(-3999, "server error. If getRange interface used, maybe limited by server. the invalid item between two valid items must less than 4096. getRange scan items must less than 100000. change start/end key and try again");
  static TairResultCode VERERROR = createTairResultCode(-3997, "version error. Always happened in highly concurrent write circumstances, try reduce concurrency");
  static TairResultCode TYPENOTMATCH = createTairResultCode(-3996, "type not match");
  static TairResultCode PLUGINERROR = createTairResultCode(-3995, "plugin error");
  static TairResultCode SERIALIZEERROR = createTairResultCode(-3994, "serialize error. If write interface used, please ensure every member in the enter param class able to serialize, also check value < 1M.If read interface used,Please check whether the incoming key or value change the serialize method, such as changing the sequence of class member, add/delete member, change class path.. Make sure custom deserialize classes can be found");
  static TairResultCode ITEMEMPRY = createTairResultCode(-3993, "item empty");
  static TairResultCode OUTOFRANGE = createTairResultCode(-3992, "item out of range");
  static TairResultCode ITEMSIZEERROR = createTairResultCode(-3991, "item size error. Check whether the key or value size 0, key is greater than 1k, value is greater than 1M. If incr / decr / setcount interface used and other counts, also check the value isn't less than 0.");
  static TairResultCode SENDFAILED = createTairResultCode(-3990, "send packet failed. Please check the status of the application server network");
  static TairResultCode TIMEOUT = createTairResultCode(-3989, "timeout");
  static TairResultCode DATAEXPIRED = createTairResultCode(-3988, "data expired");
  static TairResultCode SERVERCANTWORK = createTairResultCode(-3987, "server can not work");
  static TairResultCode WRITENOTONMASTER = createTairResultCode(-3986, "write not on master. server data migration, please wait a moment and try again");
  static TairResultCode DUPLICATEBUSY = createTairResultCode(-3985, "duplicate busy");
  static TairResultCode MIGRATEBUSY = createTairResultCode(-3984, "migrate busy. server data migration, please wait a moment and try again");
  static TairResultCode INVALIDARG = createTairResultCode(-3982, "invalid argument");
  static TairResultCode CANNT_OVERRIDE = createTairResultCode(-3981, "can not override. Counter interfaces and common interface can not be mixed, don't call put method before incr / decr, similar prefix method.");
  static TairResultCode COUNT_BOUNDS = createTairResultCode(-3980, "count reach bound");
  static TairResultCode COUNT_ZERO = createTairResultCode(-3979, "count reach zero");
  static TairResultCode COUNT_NOTFOUND = createTairResultCode(-3978, "count not exist");
  static TairResultCode INVAL_CONN_ERROR = createTairResultCode(-3970, "invalid server can't connect to dataserver");
  static TairResultCode ITEM_HIDDEN = createTairResultCode(-3969, "item is hidden, use getHidden method");
  static TairResultCode ITEM_NEGLECTED = createTairResultCode(-3966, "item is neglected");
  static TairResultCode QUEUE_OVERFLOWED = createTairResultCode(-3968, "server-side task queue overflowed");
  static TairResultCode SHOULD_PROXY = createTairResultCode(-3967, "key should proxy.Cluster migration occurs, please try again later");
  static TairResultCode LOCK_EXIST = createTairResultCode(-3975, "lock already exist. Check the application code logic, cant lock twice");
  static TairResultCode LOCK_NOT_EXIST = createTairResultCode(-3974, "lock not exist. Check the application code logic, cant unlock twice");
  static TairResultCode REMOVE_NOT_ON_MASTER = new TairResultCode(-4101, "write not on master. server data migration, please wait a moment and try again");
  static TairResultCode NAMESPACE_EXISTED = createTairResultCode(-4204, "namespace already exists");
  static TairResultCode COUNTER_OUT_OF_RANGE = createTairResultCode(-5114, "counter out of the range");
  static TairResultCode MODIFYTIMEERROR = createTairResultCode(-5115, "modify time smaller than server time");
  static TairResultCode TARGET_NOT_NUMBER = createTairResultCode(-20001, "target not number");
  static TairResultCode TARGET_NOT_int = createTairResultCode(-20002, "target not int");
  static TairResultCode TARGET_NOT_DOUBLE = createTairResultCode(-20003, "target not double");
  static TairResultCode TARGET_ALREADY_EXIST = createTairResultCode(-20004, "target has exist");
  static TairResultCode TARGET_RANGE_HAVE_NONE = createTairResultCode(-20005, "range_have none");
  static TairResultCode TAIR_INCDECR_OVERFLOW = createTairResultCode(-20006, "data overflow");
  static TairResultCode TAIR_DATA_LEN_LIMIT = createTairResultCode(-20007, "data len too int");
  static TairResultCode TAIR_IS_NOT_SUPPORT = createTairResultCode(-20008, "not support");
  static TairResultCode TAIR_RANGE_OUT_OF_LIMIT = createTairResultCode(-20010, "range count reach limit");
  static TairResultCode GC_STATUS_FINISHED = createTairResultCode(-5201, "gc status finished");
  static TairResultCode GC_STATUS_UNFINISHED = createTairResultCode(-5202, "gc status unfinished");
  static TairResultCode GC_STATUS_FAILED = createTairResultCode(-5203, "request failed");
  static TairResultCode NS_READ_ONLY = createTairResultCode(-5117, "namespace is read only");
  static TairResultCode TOO_MANY_KEYS = createTairResultCode(-5118, "too many keys or keys empty");
  static TairResultCode WAIT_TOKEN = createTairResultCode(-5119, "wait token");
  static TairResultCode TAIR_RPC_OVERFLOW = new TairResultCode(-6000, "rpc overflow, flow limited. Check hot key access and the sudden increase qps");
  static TairResultCode TAIR_SPH_CONTROL = new TairResultCode(-6001, "sph control limit(too much concurrent call) use tairManager.setMaxWaitThread() to adjust this limit");
  static TairResultCode ERROR_BEFORE_SEND = new TairResultCode(-6002, "error happened before net send");
  static TairResultCode PRESSURE_TEST_INTERCEPT = new TairResultCode(3, "Intercept between pressure testing");
  static TairResultCode CONNECT_DOWN_SERVER = new TairResultCode(-6003, "connect error, server node may down");
  static TairResultCode BUCKET_ERROR = new TairResultCode(-6004, "keys not in the same bucket. Use getBucketOfKey check");
  static TairResultCode Interrupted = new TairResultCode(-6005, "Thead be Interrupted");
  static TairResultCode CALLBACK_THREADPOOL_FULL = new TairResultCode(-6006, "no idel executor to callback");
  static TairResultCode KEY_IS_FORBIDDEN = new TairResultCode(-10000, "this key is forbidden to access");
  

  static TairResultCode createTairResultCode(int code, String message) {
    TairResultCode tairResultCode = new TairResultCode(code, message);
    if (code == 1) {
      codeMap[-3998] = tairResultCode;
    } else if (code == -10) {
      codeMap[-3983] = tairResultCode;
    } else if (code == -20008) {
      codeMap[-4001] = tairResultCode;
    }

    codeMap[code]  = tairResultCode;
    return tairResultCode;
  }

static TairResultCode valueOf(int code) {
  TairResultCode tairResultCode = codeMap[code];
  if (TairResultCode == null) {
    return UNKNOW;
  } else {
    return tairResultCode;
  }
}

bool isSuccess() {
  return code >= 0;
}

String toString() {
  return "code=${code}, msg=${message}";
}

}
