import 'dart:convert';

import 'package:saker/plugin/faas/common/event/message.dart';
import 'package:saker/plugin/faas/common/event/message_queue.dart';
import 'package:saker/plugin/faas/container/function.dart';

class MessageQueueEvent extends Event{

  PMessageQueue _messageQueue;

  MessageQueueEvent(): super(eventTypeMap[METAQ]){
    _messageQueue = _buildMessageQueue();
  }

  MessageQueueEvent.forMessage(PMessageQueue q):
        super(eventTypeMap[func_evt_metaq]){
     _messageQueue = q;
  }

  List<PMessage> getMessages()=>_messageQueue.metaqMsgList;

  String getBrokerName()=> _messageQueue.brokerName;

  PMessageQueue _buildMessageQueue(){
   final PMessageQueue q = new PMessageQueue();
    if(data!=null){
      q.fromJson(data);
    }
    return q;
  }

  @override
  String toString() => "${json.encode(_messageQueue.metaqMsgList)}";


  @override
  Map get data => _messageQueue?.toJson();


}