import 'dart:convert';
import 'dart:io';
import 'package:path/path.dart';
import 'package:saker/framework/log/log.dart';
import 'package:saker/framework/reloader/reload_source.dart';
import 'package:saker/framework/services/service_var.dart';
import 'package:saker/plugin/faas/common/instances.dart';


void initContainerMonitor(String path){
  Map result = {
    "success": true,
    "errorCode": "",
    "errorMsg": ""
  };
  healthResult = json.encode(result);
  final Map<String,String> triggerMap = {};
  Directory parentPath = Directory(path).parent;
  if(Directory(path).existsSync()) {
    List<FileSystemEntity>  files = Directory(path).listSync();
    if(files.length > 0){
      Directory(path).listSync().forEach((triggerFile) {
        triggerMap[basename(triggerFile.path)] =
            new File(triggerFile.path).readAsStringSync();
      });
    }else if(new File(parentPath.path+"/mtop.yaml").existsSync()){
      triggerMap['mtop.yaml'] = new File(parentPath.path+"/mtop.yaml").readAsStringSync();
    }else{
      throw Exception('Trigger not found  ${path}');;
    }

  }
  result = {
    'success': true,
    'errorCode': '',
    'errorMsg': '',
    'data' : {
      'functionName': functionName,
      'functionVersion': functionVersion,
      'configs': triggerMap
    }
  };
  configResult = json.encode(result);
}


Processing health = (HttpRequest  request) {
    if (svcOfflineStatus == 0) {
      if (healthResult == '') {
        initContainerMonitor(mtopConfigpath);
      }
      request.response
        ..write(healthResult)
        ..close().catchError((e) =>
            MyLogger.getLogger().error('Health response:$e'));
    } else {
      request.response
        ..statusCode = HttpStatus.notFound
        ..write('ECHO')
        ..close().catchError((e) =>
            MyLogger.getLogger().error('Health response:$e'));

      MyLogger.getLogger().error('HTTP Health Offline');
    }

};

Processing survive = (HttpRequest request) {
    request.response
      ..write('ECHO')
      ..close().catchError((e) =>
          MyLogger.getLogger().error('Survive response:$e'));
};

Processing config = (HttpRequest request) {
    if (svcOfflineStatus == 0) {
      if (configResult == '') {
        initContainerMonitor(mtopConfigpath);
      }
      request.response
        ..write(configResult)
        ..close().catchError((e) =>
            MyLogger.getLogger().error('Config response:$e'));
    } else {
      request.response
        ..statusCode = HttpStatus.notFound
        ..write('ECHO')
        ..close().catchError((e) =>
            MyLogger.getLogger().error('Config response:$e'));
      MyLogger.getLogger().error('HTTP Config Offline');
    }

};


Processing  hotReload = (HttpRequest request) async{
  List<String> ids = await findAllHttpIsolateIds();
  bool isOK = true;
  for(String id in ids){
    isOK &= await reloadSource(id, '/home/admin/gaia/target/function.dill');
  }

    request.response
      ..write(isOK)
      ..close().catchError((e) =>
          MyLogger.getLogger().error('hotreload response:$e'));

};

