@TestOn("linux || mac-os")

import 'dart:convert';
import 'dart:typed_data';
import 'package:convert/convert.dart';
import 'package:crypto/crypto.dart' as crypto;
import 'package:pointycastle/api.dart';
import 'package:pointycastle/block/aes_fast.dart';
import 'package:pointycastle/block/modes/cbc.dart';
import 'package:pointycastle/padded_block_cipher/padded_block_cipher_impl.dart';
import 'package:pointycastle/paddings/pkcs7.dart';
import 'package:saker/common/utils/dart_encrypt.dart';
import 'package:test/test.dart';

void main() {
  group('加密测试', () {
    test('基础', () {
      var md5 = crypto.md5;
      var digest = md5.convert(utf8.encode("user_id_encrypt_key_5002"));
      var key = hex.encode(digest.bytes);

      var iv1 = utf8.encode(key).sublist(0, 16);
      var iv = new Uint8List.fromList(iv1);

      KeyParameter keyParameter = new KeyParameter(iv);

      CBCBlockCipher cbcBlockCipher = new CBCBlockCipher(new AESFastEngine());
      ParametersWithIV parametersWithIV = new ParametersWithIV(
          keyParameter, iv);

      PaddedBlockCipher paddedBlockCipher = new PaddedBlockCipherImpl(
          new PKCS7Padding(), cbcBlockCipher);

      CipherParameters parameters = new PaddedBlockCipherParameters(
          parametersWithIV, null);

      paddedBlockCipher.init(true, parameters);

      var a = paddedBlockCipher.process(new Uint8List.fromList(utf8.encode('1234567812345678')));
      var s = base64.encode(a);
      expect(s,'saEzm084P4q3Ltfly0EvI2bNhzqNxxswecTfzGHelGE=');
    });

    test('框架方法', () {
      String s = EncryptTools.encryptAesCbcWithPKCS7('1234567812345678', "user_id_encrypt_key_5002");
      expect(s,'saEzm084P4q3Ltfly0EvI2bNhzqNxxswecTfzGHelGE=');
    });
  });
}