@TestOn("linux || mac-os")

import 'package:test/test.dart';
import 'package:saker/common/utils/date_utils.dart';

void main() {
  setUp(() async {
  });

  group('日期工具类', () {
    test('日期格式化', () {
      DateTime dateTime = new DateTime(2018, 3, 6, 13, 4, 59, 123, 789);

      String s1 = DateTools.formatDateTime(dateTime, 'yyyy-MM-dd');
      expect(s1, '2018-03-06');

      String s2 = DateTools.formatDateTime(dateTime, 'yyyy-MM-dd HH:mm:ss');
      expect(s2, '2018-03-06 13:04:59');

      String s3 = DateTools.formatDateTime(dateTime, 'hh:mm:ss');
      expect(s3, '01:04:59');

      String s4 = DateTools.formatDateTime(dateTime, 'yyMMdd');
      expect(s4, '180306');

      DateTime d1 = DateTools.parseDateTime(s1, 'yyyy-MM-dd');
      expect(d1.year, 2018);
      expect(d1.month, 3);
      expect(d1.day, 6);

      DateTime d2 = DateTools.parseDateTime(s2, 'yyyy-MM-dd hh:mm:ss');
      expect(d2.year, 2018);
      expect(d2.month, 3);
      expect(d2.day, 6);
      expect(d2.hour, 13);
      expect(d2.minute, 4);
      expect(d2.second, 59);
    });
  });
}