@TestOn("linux || mac-os")

import 'dart:isolate';
import 'package:saker/common/utils/type_cast.dart';
import 'package:saker/framework/event/event_pool.dart';
import 'package:saker/framework/event/event_pool_base.dart';
import 'package:test/test.dart';

SendPort peerSendPort;
int index = 1;

void test_notice_callback(dynamic messages) {
  if (messages is List) {
    return;
  }

  SendPort s = messages[0] as SendPort;
  int eventId = messages[1] as int;

  s.send([EventType_Any, eventId, EventStatus_OK, index++]);
}

test_event_pool_isolate_entry(dynamic messages) async {
  if (messages is List) {
    return;
  }

  peerSendPort = messages[2] as SendPort;
  EventPool.notice_cb = test_notice_callback;

  await peerSendPort.send([EventType_Any, messages[0], messages[1], messages[2]]);
}

void main() {
  group('Event Pool', () {
    test('发送接收', () async {
      EventPool.notice_cb = test_notice_callback;

      EventItem item = EventPool.getEvent();

      await Isolate.spawn(test_event_pool_isolate_entry, [item.id, EventStatus_OK, item.sendPort])
          .catchError((e) => print('$e'));

      peerSendPort = safeCast(await item.future);

      expect(peerSendPort != null, true);

      for (int i = 1 ; i < 3; i++) {
        EventItem item2 = EventPool.getEvent();
        peerSendPort.send([EventType_Notice, [item2.sendPort, item2.id]]);

        int x = safeCast(await item2.future);

        expect(x, i);
      }
    });
  });
}

