import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'dart:isolate';

@TestOn("linux || mac-os")

import 'package:test/test.dart';

test_http_listener1(var messages) {
  HttpServer.bind('0.0.0.0', 8080, shared: true).then((server) {
    StreamSubscription subscription;
    subscription = server.listen((HttpRequest request) {
      print('L1 ${request.method}');
      request.response..write("OK")..close();
      sleep(new Duration(milliseconds: 100));
    }, onDone: () {
      subscription.cancel();
    });
  }).catchError((e) {
  });
}

test_http_listener2(var messages) {
  HttpServer.bind('0.0.0.0', 8080, shared: true).then((server) {
    StreamSubscription subscription;
    subscription = server.listen((HttpRequest request) {
      print('L2 ${request.method}');
      request.response..write("OK")..close();
      sleep(new Duration(milliseconds: 200));
    }, onDone: () {
      subscription.cancel();
    });
  }).catchError((e) {
  });
}

void main() {
  group('Http Listener', () {
    test('基础', () async {
      await Isolate.spawn(test_http_listener1, [])
          .catchError((e) => print('$e'));

      await Isolate.spawn(test_http_listener2, [])
          .catchError((e) => print('$e'));

      new Future.delayed(new Duration(seconds: 1));

      for (int i = 0; i < 20; i++) {
        HttpClientRequest request = await new HttpClient().post(
            '127.0.0.1', 8080, '/Hello${i}');
        HttpClientResponse response = await request.close();
      }
    });
  });
}